unit FormBodySourceEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TntStdCtrls, SpTBXEditors, SpTBXDkPanels, TBXDkPanels,
  ShellAPI, IniFiles;

type
  TFormEditSource = class(TForm)
    SpTBXLabel1: TSpTBXLabel;
    StartEditButton: TSpTBXButton;
    SpTBXGroupBox1: TSpTBXGroupBox;
    EditorSelectBox: TSpTBXComboBox;
    SpTBXButton2: TSpTBXButton;
    OpenDialog: TOpenDialog;
    SpTBXButton3: TSpTBXButton;
    SpTBXButton4: TSpTBXButton;
    procedure SpTBXButton2Click(Sender: TObject);
    procedure StartEditButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpTBXButton3Click(Sender: TObject);
  private
    { Private 錾 }
    FEditMode: Boolean;
  public
    { Public 錾 }
    FExecEditor: Boolean;
    FEditPath: String;
  end;

var
  FormEditSource: TFormEditSource;

implementation

uses main;

{$R *.dfm}

procedure TFormEditSource.SpTBXButton2Click(Sender: TObject);
begin
  if OpenDialog.Execute then
    EditorSelectBox.Text := OpenDialog.FileName;
end;

procedure TFormEditSource.StartEditButtonClick(Sender: TObject);
var
  idx: Integer;
  Mem: TMemIniFile;
begin
  if FEditMode = False then
  begin
    FEditMode := True;
    StartEditButton.Caption := 'ҏWI(&O)';
    StartEditButton.ModalResult := mrOk;
    EditorSelectBox.Enabled := False;
    SpTBXButton2.Enabled := False;
    SpTBXLabel1.Enabled := False;
    ShellExecute(Handle,'open',PChar(String(EditorSelectBox.Text)),
      PChar(self.FEditPath),nil,SW_SHOW);
    CreateDir(ExtractFilePath(Application.ExeName) + 'Settings');
    idx := EditorSelectBox.Items.IndexOf(EditorSelectBox.Text);
    if idx <> -1 then
      EditorSelectBox.Items.Delete(idx);
    EditorSelectBox.Items.Insert(0,EditorSelectBox.Text);
    EditorSelectBox.Items.SaveToFile(
      ExtractFilePath(Application.ExeName) + 'Settings\SelEditor.db');
    Mem := TMemIniFile.Create(ExtractFilePath(Application.ExeName) +
      'Setting.ini');
    try
      Mem.WriteString('Option','ActiveEditor',EditorSelectBox.Text);
      Mem.UpdateFile;
    finally
      Mem.Free;
    end;
  end;
end;

procedure TFormEditSource.FormCreate(Sender: TObject);
var
  Mem: TMemIniFile;
begin
  FEditMode := False;
  if FileExists(ExtractFilePath(Application.ExeName) +
    'Settings\SelEditor.db') then
    EditorSelectBox.Items.LoadFromFile(
      ExtractFilePath(Application.ExeName) + 'Settings\SelEditor.db');
  Mem := TMemIniFile.Create(ExtractFilePath(Application.ExeName) +
    'Setting.ini');
  try
    EditorSelectBox.Text :=
      Mem.ReadString('Option','ActiveEditor',EditorSelectBox.Text);
  finally
    Mem.Free;
  end;
end;

procedure TFormEditSource.FormShow(Sender: TObject);
begin
  if FExecEditor then
  begin
    StartEditButtonClick(StartEditButton);
    FExecEditor := False;
  end;
end;

procedure TFormEditSource.SpTBXButton3Click(Sender: TObject);
begin
  if po <> nil then
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051130183445515.htm'),HH_DISPLAY_TOC,0);
end;

end.
