unit FormControlCapt;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXDkPanels, TBXDkPanels, ExtCtrls;

type
  TControlCaptForm = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    StartPicker: TImage;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXButton1: TSpTBXButton;
    SpTBXButton3: TSpTBXButton;
    procedure StartPickerMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartPickerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StartPickerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpTBXButton3Click(Sender: TObject);
  private
    { Private 錾 }
    FWndCapt: Boolean;
    procedure HighLightWnd(Wnd: HWND; SetDraw: Boolean);
  public
    { Public 錾 }
    FPrevHWnd: HWND;
  end;

var
  ControlCaptForm: TControlCaptForm;

implementation

uses main;

{$R *.dfm}

//RA͈ȉQ
//http://www.nitoyon.com/vc/tips/gui/select_window.htm

procedure TControlCaptForm.HighLightWnd(Wnd: HWND; SetDraw: Boolean);
var
  dc: HDC;
  Rc: TRect;
begin
  if (Wnd = 0) or (IsWindow(Wnd) = False) then
    Exit;

	dc := GetWindowDC(Wnd);
  try
    GetWindowRect(Wnd, Rc);
    OffsetRect(Rc, -Rc.left, -Rc.top);

    if not IsRectEmpty(Rc) then
    begin
      PatBlt(dc, Rc.left, Rc.top, Rc.right - Rc.left, 3,  DSTINVERT);
      PatBlt(dc, Rc.left, Rc.bottom - 3, 3,
        -(Rc.bottom - Rc.top - 2 * 3), DSTINVERT);
      PatBlt(dc, Rc.right - 3, Rc.top + 3, 3,
        Rc.bottom - Rc.top - 2 * 3, DSTINVERT);
      PatBlt(dc, Rc.right, Rc.bottom - 3, -(Rc.right - Rc.left),
        3, DSTINVERT);
    end;
  finally
    ReleaseDC(Wnd, dc);
  end;
end;

procedure TControlCaptForm.StartPickerMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Screen.Cursor := crCross;
  SetCapture(SpTBXPanel1.Handle);
  StartPicker.Hide;
  FWndCapt := True;
end;

procedure TControlCaptForm.StartPickerMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if FWndCapt then
  begin
    Screen.Cursor := crDefault;
    Hide;
    ReleaseCapture;
    StartPicker.Show;
    FWndCapt := False;
    HighLightWnd(FPrevHWnd,False);
    ModalResult := mrOk;
  end;
end;

procedure TControlCaptForm.StartPickerMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  Poi: TPoint;
  Wnd,WndChild: HWND;
begin
  if FWndCapt then
  begin
    GetCursorPos(Poi);
    Wnd := WindowFromPoint(Poi);
    if Wnd <> 0 then
    begin
      Windows.ScreenToClient(Wnd, Poi);
      WndChild := ChildWindowFromPoint(Wnd, Poi);
      if WndChild <> 0 then
        Wnd := WndChild;
    end;

    if Wnd <> FPrevHWnd then
    begin
      HighLightWnd(FPrevHWnd,False);
      FPrevHWnd := Wnd;
      HighLightWnd(FPrevHWnd,True);
    end;
  end;
end;

procedure TControlCaptForm.SpTBXButton3Click(Sender: TObject);
begin
  if po <> nil then
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/2005113018284062.htm'),HH_DISPLAY_TOC,0);
end;

end.
