unit FormCustomTag;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TBXDkPanels, SpTBXDkPanels, StdCtrls;

type
  TCustomTagItem = class
    Name: String;
    TagA: String;
    TagB: String;
  end;

type
  TCustomTagForm = class(TForm)
    SpTBXGroupBox1: TSpTBXGroupBox;
    TagList: TListBox;
    SpTBXButton1: TSpTBXButton;
    SpTBXButton2: TSpTBXButton;
    SpTBXButton3: TSpTBXButton;
    SpTBXButton4: TSpTBXButton;
    SpTBXButton5: TSpTBXButton;
    SpTBXButton6: TSpTBXButton;
    procedure SpTBXButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpTBXButton2Click(Sender: TObject);
    procedure SpTBXButton4Click(Sender: TObject);
    procedure SpTBXButton3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TagListClick(Sender: TObject);
    procedure TagListDblClick(Sender: TObject);
    procedure SpTBXButton6Click(Sender: TObject);
    procedure TagListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private 錾 }
    procedure SaveToCustomTag(const Path: String);
    procedure LoadFromCustomTag(const Path: String);
  public
    { Public 錾 }
    FInsertA: String;
    FInsertB: String;
  end;

var
  CustomTagForm: TCustomTagForm;

implementation

uses FormAddCustomTag, main;

{$R *.dfm}

procedure TCustomTagForm.LoadFromCustomTag(const Path: String);
var
  ls,ads: TStringList;
  i,x,newx: Integer;
  Item: TCustomTagItem;
begin
  if FileExists(Path) = False then
    Exit;
  ls := TStringList.Create;
  ads := TStringList.Create;
  try
    ls.LoadFromFile(Path);
    for i := 0 to ls.Count - 1 do
    begin
      if ls[i] = '' then
        Continue;
      if ls[i][1] = '/' then
      begin
        Item := TCustomTagItem.Create;
        try
          Item.Name := Copy(ls[i],2,Length(ls[i]));
          ads.Clear;
          newx := i + 1;
          for x := i + 1 to ls.Count-1 do
          begin
            newx := x;
            if ls[x][1] = '+' then
            begin
              ads.Add(Copy(ls[x],2,Length(ls[x])));
            end;
            if ls[x][1] = '-' then
              Break;
          end;
          Item.TagA := ads.Text;

          ads.Clear;
          for x := newx + 1 to ls.Count-1 do
          begin
            if ls[x][1] = '+' then
            begin
              ads.Add(Copy(ls[x],2,Length(ls[x])));
            end;
            if ls[x][1] = '/' then
              Break;
          end;
          Item.TagB := ads.Text;
        finally
          TagList.Items.AddObject(Item.Name,Item);
        end;
      end;
    end;
  finally
    ls.Free;
    ads.Free;
  end;
end;

procedure TCustomTagForm.SaveToCustomTag(const Path: String);
var
  ls,ads: TStringList;
  i,x: integer;
begin
  ls := TStringList.Create;
  ads := TStringList.Create;
  try
    for i := 0 to TagList.Count-1 do
    begin
      ls.Add('/' + TCustomTagItem(TagList.Items.Objects[i]).Name);
      ads.Text := TCustomTagItem(TagList.Items.Objects[i]).TagA;
      for x := 0 to ads.Count-1 do
      begin
        ls.Add('+' + ads[x]);
      end;
      ls.Add('-TagB');
      ads.Text := TCustomTagItem(TagList.Items.Objects[i]).TagB;
      for x := 0 to ads.Count-1 do
      begin
        ls.Add('+' + ads[x]);
      end;
    end;
    ls.SaveToFile(Path);
  finally
    ads.Free;
    ls.Free;
  end;
end;

procedure TCustomTagForm.SpTBXButton1Click(Sender: TObject);
var
  F: TAddCustomTagForm;
  Item: TCustomTagItem;
begin
  F := TAddCustomTagForm.Create(self);
  if F.ShowModal = mrok then
  begin
    Item := TCustomTagItem.Create;
    Item.Name := F.TagNameEdit.Text;
    Item.TagA := F.TagA.Text;
    Item.TagB := F.TagB.Text;

    TagList.Items.AddObject(Item.Name,Item);
  end;
end;

procedure TCustomTagForm.FormCreate(Sender: TObject);
begin
  LoadFromCustomTag(
    ExtractFilePath(Application.ExeName) + 'Settings\CustomTags.tag');
end;

procedure TCustomTagForm.SpTBXButton2Click(Sender: TObject);
var
  F: TAddCustomTagForm;
  Item: TCustomTagItem;
begin
  if TagList.ItemIndex = -1 then
    Exit;
  Item := TCustomTagItem(TagList.Items.Objects[TagList.ItemIndex]);
  F := TAddCustomTagForm.Create(self);
  F.TagNameEdit.Text := Item.Name;
  F.TagA.Text := Item.TagA;
  F.TagB.Text := Item.TagB;
  if F.ShowModal = mrok then
  begin
    Item.Name := F.TagNameEdit.Text;
    Item.TagA := F.TagA.Text;
    Item.TagB := F.TagB.Text;
    TagList.Items[TagList.ItemIndex] := Item.Name;
  end;
end;

procedure TCustomTagForm.SpTBXButton4Click(Sender: TObject);
begin
  ForceDirectories(ExtractFilePath(Application.ExeName) + 'Settings');
  SaveToCustomTag(
    ExtractFilePath(Application.ExeName) + 'Settings\CustomTags.tag');
end;

procedure TCustomTagForm.SpTBXButton3Click(Sender: TObject);
begin
  if TagList.ItemIndex = -1 then
    Exit;
  TObject(TagList.Items.Objects[TagList.ItemIndex]).Free;
  TagList.Items.Delete(TagList.ItemIndex);
end;

procedure TCustomTagForm.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to TagList.Items.Count - 1 do
  begin
    TObject(TagList.Items.Objects[i]).Free;
  end;
end;

procedure TCustomTagForm.TagListClick(Sender: TObject);
begin
  if TagList.ItemIndex = -1 then
    Exit;
  FInsertA := TCustomTagItem(TagList.Items.Objects[TagList.ItemIndex]).TagA;
  if Copy(FInsertA,Length(FInsertA)-Length(#13#10)+1,Length(#13#10)) = #13#10 then
    Delete(FInsertA,Length(FInsertA)-Length(#13#10)+1,Length(#13#10));
  FInsertB := TCustomTagItem(TagList.Items.Objects[TagList.ItemIndex]).TagB;
  if Copy(FInsertB,Length(FInsertB)-Length(#13#10)+1,Length(#13#10)) = #13#10 then
    Delete(FInsertB,Length(FInsertB)-Length(#13#10)+1,Length(#13#10));
end;

procedure TCustomTagForm.TagListDblClick(Sender: TObject);
begin
  SpTBXButton4Click(SpTBXButton4);
  ModalResult := mrOk;
end;

procedure TCustomTagForm.SpTBXButton6Click(Sender: TObject);
begin
  if po <> nil then
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/200511301852500.htm'),HH_DISPLAY_TOC,0);
end;

procedure TCustomTagForm.TagListDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //wih
  if odSelected in State then
  begin
    TListBox(Control).Canvas.Brush.Color := clMenuHighlight;
    TListBox(Control).Canvas.FillRect(Rect);
  end else
  begin
    TListBox(Control).Canvas.Brush.Color := clWindow;
    TListBox(Control).Canvas.FillRect(Rect);
  end;

  FormMain.MenuImageList.Draw(TListBox(Control).Canvas,
    1, Rect.Top + 2, 33);

  //̕`
  TListBox(Control).Canvas.TextOut(20,Rect.Top + 3,
    TListBox(Control).Items[Index]);
end;

end.
