unit FormLinkEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, TBXDkPanels, SpTBXDkPanels, StdCtrls, SpTBXEditors,
  ExtCtrls;

type
  TLinkForm = class(TForm)
    SpTBXGroupBox1: TSpTBXGroupBox;
    LinkEdit: TSpTBXEdit;
    SpTBXButton2: TSpTBXButton;
    SpTBXGroupBox2: TSpTBXGroupBox;
    TreeView1: TTreeView;
    SpTBXGroupBox3: TSpTBXGroupBox;
    ListBox1: TListBox;
    Panel1: TPanel;
    SpTBXButton1: TSpTBXButton;
    SpTBXButton3: TSpTBXButton;
    SpTBXButton4: TSpTBXButton;
    SpTBXButton5: TSpTBXButton;
    OpenDialog1: TOpenDialog;
    SpTBXGroupBox4: TSpTBXGroupBox;
    ListBox2: TListBox;
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure SpTBXButton1Click(Sender: TObject);
    procedure SpTBXButton2Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure SpTBXButton4Click(Sender: TObject);
  private
    { Private 錾 }
    FImageForm: TForm;
    procedure CaptureScan;
  public
    { Public 錾 }
  end;

var
  LinkForm: TLinkForm;

implementation

uses main, FormImageView;

{$R *.dfm}

procedure TLinkForm.CaptureScan;
var
  sr: TSearchRec;
begin
  if FindFirst(ExtractFilePath(FormMain.FProjectFullPath) + 'Capture\*',
    faAnyFile, sr) = 0 then
  begin
    repeat
      if (sr.Name = '.') or (sr.Name = '..') then
        Continue;
      if (sr.Attr and faDirectory) = 0 then
      begin
        ListBox1.Items.Add(sr.Name);
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
end;

procedure TLinkForm.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then
  begin
    LinkEdit.Text := 'Capture\' + ListBox1.Items[ListBox1.itemindex];

    if Assigned(FImageForm)  then
    begin
      if FImageForm.Visible then
      begin
        TImageViewForm(FImageForm).TKWebBrowser1.Navigate(
          ExtractFilePath(FormMain.FProjectFullPath) + 'Capture\' +
          ListBox1.Items[ListBox1.itemindex]);
      end;
    end;
  end;
end;

procedure TLinkForm.FormCreate(Sender: TObject);
begin
  CaptureScan;
end;

procedure TLinkForm.TreeView1Click(Sender: TObject);
begin
  if TreeView1.Selected <> nil then
  begin
    if TTopicItem(TreeView1.Selected.Data).TopicType = TTPItem then
    begin
      LinkEdit.Text := ChangeFileExt(
        TTopicItem(TreeView1.Selected.Data).Path,'.htm');
    end;
  end;
end;

procedure TLinkForm.SpTBXButton1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex = -1 then
    Exit;
  if Assigned(FImageForm) = False then
    FImageForm := TImageViewForm.Create(self);

  TImageViewForm(FImageForm).TKWebBrowser1.Navigate(
    ExtractFilePath(FormMain.FProjectFullPath) + 'Capture\' +
    ListBox1.Items[ListBox1.itemindex]);
  FImageForm.Show;
end;

procedure TLinkForm.SpTBXButton2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    LinkEdit.Text :=
      ExtractRelativePath(FormMain.FProjectFullPath,
      OpenDialog1.FileName);
  end;
end;

procedure TLinkForm.ListBox1DblClick(Sender: TObject);
begin
  ModalResult := mrok;
end;

procedure TLinkForm.TreeView1DblClick(Sender: TObject);
begin
  if TreeView1.Selected <> nil then
  begin
    if TTopicItem(TreeView1.Selected.Data).TopicType = TTPItem then
    begin
      self.ModalResult := mrok;
    end;
  end;
end;

procedure TLinkForm.ListBox2DblClick(Sender: TObject);
begin
  if ListBox2.ItemIndex = -1 then
    Exit;
  FormMain.EditBrowser.JumpAnchor(ListBox2.Items[ListBox2.itemindex]);
  LinkEdit.Text := '#' + ListBox2.Items[ListBox2.itemindex];
end;

procedure TLinkForm.SpTBXButton4Click(Sender: TObject);
begin
  if po <> nil then
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051130175532750.htm'),HH_DISPLAY_TOC,0);
end;

end.
