unit FormNewWizard;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpTBXEditors, SpTBXDkPanels, ExtCtrls, TBXDkPanels,
  Menus, OleCtrls, SHDocVw_TLB, TKWebBrowser, ShellAPI;

type
  TFormWizard = class(TForm)
    Panel1: TPanel;
    NextButton: TSpTBXButton;
    BackButton: TSpTBXButton;
    SpTBXButton3: TSpTBXButton;
    SpTBXButton4: TSpTBXButton;
    Notebook1: TNotebook;
    Panel2: TPanel;
    Image1: TImage;
    Panel3: TPanel;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXLabel3: TSpTBXLabel;
    SpTBXEdit1: TSpTBXEdit;
    SpTBXEdit2: TSpTBXEdit;
    SpTBXLabel4: TSpTBXLabel;
    SpTBXEdit3: TSpTBXEdit;
    SpTBXLabel5: TSpTBXLabel;
    SpTBXEdit4: TSpTBXEdit;
    SpTBXLabel6: TSpTBXLabel;
    Panel4: TPanel;
    Panel5: TPanel;
    SpTBXLabel7: TSpTBXLabel;
    SpTBXLabel8: TSpTBXLabel;
    Panel6: TPanel;
    Panel7: TPanel;
    SpTBXLabel13: TSpTBXLabel;
    SpTBXLabel14: TSpTBXLabel;
    SpTBXLabel15: TSpTBXLabel;
    TitleBox: TSpTBXEdit;
    ProjectEdit: TSpTBXEdit;
    SpTBXLabel16: TSpTBXLabel;
    CopyEdit: TSpTBXEdit;
    SpTBXLabel17: TSpTBXLabel;
    WebEdit: TSpTBXEdit;
    SpTBXLabel18: TSpTBXLabel;
    SpTBXGroupBox1: TSpTBXGroupBox;
    SpTBXGroupBox2: TSpTBXGroupBox;
    ThemeListBox: TListBox;
    TKWebBrowser: TTKWebBrowser;
    DummyPopup: TPopupMenu;
    Panel8: TPanel;
    Panel9: TPanel;
    SpTBXLabel19: TSpTBXLabel;
    SpTBXLabel9: TSpTBXLabel;
    SpTBXGroupBox3: TSpTBXGroupBox;
    SpTBXLabel10: TSpTBXLabel;
    SpTBXLabel11: TSpTBXLabel;
    SpTBXLabel12: TSpTBXLabel;
    SpTBXLabel20: TSpTBXLabel;
    SpTBXLabel21: TSpTBXLabel;
    LabelTitle: TSpTBXLabel;
    LabelProject: TSpTBXLabel;
    LabelCopy: TSpTBXLabel;
    LabelWeb: TSpTBXLabel;
    LabelTheme: TSpTBXLabel;
    procedure FormCreate(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    procedure ThemeListBoxClick(Sender: TObject);
    procedure SpTBXButton4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure ScanTheme; //e[}̃XL
    procedure MakeProject; //vWFNg
  public
    { Public 錾 }
  end;

var
  FormWizard: TFormWizard;

implementation

uses main;

{$R *.dfm}

procedure TFormWizard.MakeProject;
var
  ProjDir,Temp: String;
  Sh: TSHFILEOPSTRUCT;
  Project: TStringList;
begin
  ProjDir := ExtractFilePath(Application.ExeName) + 'Project\' +
    LabelProject.Caption;
  ForceDirectories(ProjDir);

  //e[}tH_܂܂Rs[
  with Sh do
  begin
    Wnd := Application.Handle;
    wFunc := FO_COPY;
    Temp := LabelTheme.Caption;
    pFrom := PChar(ExtractFilePath(Application.ExeName) +
      'Theme\' + Temp + #0 + #0);
    pTo:= PChar(ProjDir + #0 + #0);
    fFlags := FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR or
      FOF_NOERRORUI;
    hNameMappings := nil;
    lpszProgressTitle := nil;
  end;
  SHFileOperation(Sh);

  //vWFNgf[^x[X
  Project := TStringList.Create;
  try
    Project.Add('[Project]');
    Project.Add('Title=' + LabelTitle.Caption);
    Project.Add('Copyright=' + LabelCopy.Caption);
    Project.Add('Web=' + LabelWeb.Caption);
    Project.Add('Theme=' + LabelTheme.Caption);

    Project.SaveToFile(ProjDir + '\' + LabelProject.Caption + '.sprj');
    ForceDirectories(ProjDir + '\Capture');
  finally
    Project.Free;
  end;
end;

procedure TFormWizard.ScanTheme;
var
  sr: TSearchRec;
  FullDir: String;
begin
  ThemeListBox.Items.Clear;
  FullDir := ExtractFilePath(Application.ExeName) + 'Theme\';
  if FindFirst(FullDir + '*',faAnyFile, sr) = 0 then
  begin
    repeat
      if (sr.Name = '.') or (sr.Name = '..') then
        Continue;
      if (sr.Attr and faDirectory) <> 0 then
      begin
        //ƃt@CΏE
        if FileExists(FullDir + sr.Name + '\footer.htm') then
        begin
          ThemeListBox.Items.Add(sr.Name);
        end;
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
end;

procedure TFormWizard.FormCreate(Sender: TObject);
begin
  NoteBook1.PageIndex := 0;
end;

procedure TFormWizard.NextButtonClick(Sender: TObject);
begin
  case NoteBook1.PageIndex of
  0:begin
      if (TitleBox.Text = '') or (ProjectEdit.Text = '') then
      begin
        ShowMessage('K{ڂIĂ');
        Exit;
      end;
      if DirectoryExists(
        ExtractFilePath(Application.ExeName) + 'Project\' + ProjectEdit.Text) then
      begin
        ShowMessage('̃vWFNg͊ɑ݂Ă܂B');
        Exit;
      end;
      BackButton.Enabled := True;
      ScanTheme;
    end;
  1:begin
      if LabelTheme.Caption = '' then
      begin
        ShowMessage('e[}IĂ');
        Exit;
      end;
      LabelTitle.Caption := TitleBox.Text;
      LabelProject.Caption := ProjectEdit.Text;
      LabelCopy.Caption := CopyEdit.Text;
      LabelWeb.Caption := WebEdit.Text;
      NextButton.Caption := '(&N)';
    end;
  2:begin
      MakeProject;
      ModalResult := mrok;
    end;
  end;
  NoteBook1.PageIndex := NoteBook1.PageIndex + 1;
end;

procedure TFormWizard.BackButtonClick(Sender: TObject);
begin
  case NoteBook1.PageIndex of
  1:begin
      NextButton.Caption := '(&N)';
      BackButton.Enabled := False;
    end;
  end;
  NoteBook1.PageIndex := NoteBook1.PageIndex - 1;
end;

procedure TFormWizard.ThemeListBoxClick(Sender: TObject);
var
  GenList,AddList: TStringList;
  ThemeFol,ThemeFol2: String;
begin
  if ThemeListBox.ItemIndex = -1 then
    Exit;

  LabelTheme.Caption := ThemeListBox.Items[ThemeListBox.itemindex];

  //[h
  ThemeFol := ExtractFilePath(Application.ExeName) + 'Theme\' +
    ThemeListBox.Items[ThemeListBox.itemindex] + '\';
  ThemeFol2 := ExtractFilePath(Application.ExeName) + 'Theme\';

  GenList := TStringList.Create;
  AddList := TStringList.Create;
  try
    if FileExists(ThemeFol + 'header.htm') then
      GenList.LoadFromFile(ThemeFol + 'header.htm');

    //Kɒg
      GenList.Add('<p>TvwvTvwv</p>');
      GenList.Add('<p>TvwvTvwvTvwvTvwv</p>');
      GenList.Add('<p>TvwvTvwvTvwvTvwvTvwvTvwv</p>');
      GenList.Add('<p>TvwvTvwvTvwvTvwvTvwvTvwvTvwvTvwv</p>');
    //I

    if FileExists(ThemeFol + 'footer.htm') then
      AddList.LoadFromFile(ThemeFol + 'footer.htm');
    GenList.AddStrings(AddList);

    //Kɂł
      GenList.Text := StringReplace(GenList.Text,'<!--%TipTitle%-->',
        TitleBox.Text,[rfReplaceAll, rfIgnoreCase]);
      GenList.Text := StringReplace(GenList.Text,'<!--%HelpCopyRight%-->',
        CopyEdit.Text,[rfReplaceAll, rfIgnoreCase]);
      GenList.Text := FormMain.ConvartConst(GenList.Text,nil,nil);
    //I

    DeleteFile(ThemeFol2+'preview.htm');
    GenList.SaveToFile(ThemeFol2+'preview.htm');
    FileSetAttr(ThemeFol2+'preview.htm',faHidden);
    TKWebBrowser.Navigate(ThemeFol2+'preview.htm');
  finally
    AddList.Free;
    GenList.Free;
  end;
end;

procedure TFormWizard.SpTBXButton4Click(Sender: TObject);
var
  Str: String;
begin
  case NoteBook1.PageIndex of
  0:
    begin
      Str := '::/' + '20051129181240484.htm#wnd1';
    end;
  1:
    begin
      Str := '::/' + '20051129181240484.htm#wnd2';
    end;
  2:
    begin
      Str := '::/' + '20051129181240484.htm#wnd3';
    end;
  end;
  if po <> nil then
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm' + str),HH_DISPLAY_TOC,0);
end;

end.
