unit FormSetCapture;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TSetCaptureForm = class(TForm)
    CaptureImage: TImage;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
    MoveMode: Boolean;
  public
    { Public 錾 }
    FClickPoint,FPrevPoint: TPoint;
  end;

var
  SetCaptureForm: TSetCaptureForm;

implementation

{$R *.dfm}

procedure TSetCaptureForm.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    MoveMode := True;
    FClickPoint.x := X;
    FClickPoint.y := Y;
    FPrevPoint := FClickPoint;
  end;
end;

procedure TSetCaptureForm.FormMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    FPrevPoint.x := X;
    FPrevPoint.y := Y;
    MoveMode := False;
    ModalResult := mrOk;
  end;
end;

procedure TSetCaptureForm.FormMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if MoveMode then
  begin
    Canvas.Pen.Mode := pmNotXor;
    Canvas.Pen.Color := clBlack;
    Canvas.Brush.Style := bsClear;

    Canvas.Rectangle(FClickPoint.x,FClickPoint.y,FPrevPoint.x,FPrevPoint.y);
    Canvas.Rectangle(FClickPoint.x,FClickPoint.y,X,Y);

    FPrevPoint.x := X;
    FPrevPoint.y := Y;
  end;
end;

procedure TSetCaptureForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
end;

end.
