unit FormUserTool;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXDkPanels, StdCtrls, TBXDkPanels, AppEvnts;

type
  TUserToolForm = class(TForm)
    SpTBXGroupBox1: TSpTBXGroupBox;
    UserToolBox: TListBox;
    SpTBXButton1: TSpTBXButton;
    SpTBXButton2: TSpTBXButton;
    SpTBXButton3: TSpTBXButton;
    SpTBXButton4: TSpTBXButton;
    SpTBXButton5: TSpTBXButton;
    SpTBXButton6: TSpTBXButton;
    SpTBXButton7: TSpTBXButton;
    SpTBXButton8: TSpTBXButton;
    ApplicationEvents: TApplicationEvents;
    procedure SpTBXButton1Click(Sender: TObject);
    procedure SpTBXButton2Click(Sender: TObject);
    procedure SpTBXButton5Click(Sender: TObject);
    procedure SpTBXButton8Click(Sender: TObject);
    procedure SpTBXButton6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpTBXButton3Click(Sender: TObject);
    procedure SpTBXButton4Click(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure UserToolBoxDblClick(Sender: TObject);
    procedure UserToolBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private 錾 }
    procedure SaveToCustomTool(const Path: String);
    procedure LoadFromCustomTool(const Path: String);
  public
    { Public 錾 }
  end;

var
  UserToolForm: TUserToolForm;

implementation

uses main, FormAddCustomTool;

{$R *.dfm}

procedure TUserToolForm.LoadFromCustomTool(const Path: String);
var
  ls,lsx: TStringList;

  i,x: integer;
  O: TUserToolitem;
begin
  //ǂݏo
  ls := TStringList.Create;
  lsx := TStringList.Create;
  try
    if FileExists(Path) then
      ls.LoadFromFile(Path);

    for i := 0 to ls.Count-1 do
    begin
      O := TUserToolitem.Create;
      lsx.Text := StringReplace(ls[i],#9,#13#10,[rfReplaceAll, rfIgnoreCase]);
      for x := 0 to lsx.Count-1 do
      begin
        case x of
        0:O.Name := lsx[x];
        1:O.Path := lsx[x];
        end;
      end;
      UserToolBox.AddItem(O.Name,O);
    end;
  finally
    lsx.Free;
    ls.Free;
  end;
end;

procedure TUserToolForm.SaveToCustomTool(const Path: String);
var
  ls: TStringList;
  i: integer;
  O: TUserToolitem;
begin
  ls := TStringList.Create;
  try
    for i := 0 to UserToolBox.Items.Count-1 do
    begin
      O := TUserToolitem(UserToolBox.Items.Objects[i]);
      ls.Add(O.Name + #9 +
        O.Path + #9);
    end;
    ls.SaveToFile(Path);
  finally
    ls.Free;
  end;
end;

procedure TUserToolForm.SpTBXButton1Click(Sender: TObject);
var
  F: TAddCustomToolForm;
  Item: TUserToolitem;
begin
  F := TAddCustomToolForm.Create(self);
  if F.ShowModal = mrok then
  begin
    Item := TUserToolitem.Create;
    Item.Name := F.NameEdit.Text;
    Item.Path := F.PathEdit.Text;
    UserToolBox.AddItem(Item.Name,Item);
  end;
end;

procedure TUserToolForm.SpTBXButton2Click(Sender: TObject);
var
  F: TAddCustomToolForm;
  Item: TUserToolitem;
begin
  if UserToolBox.ItemIndex = -1 then
    Exit;

  Item := TUserToolitem(UserToolBox.Items.Objects[UserToolBox.ItemIndex]);
  F := TAddCustomToolForm.Create(self);
  F.NameEdit.Text := Item.Name;
  F.PathEdit.Text := Item.Path;
  if F.ShowModal = mrok then
  begin
    Item.Name := F.NameEdit.Text;
    Item.Path := F.PathEdit.Text;
    UserToolBox.Items[UserToolBox.ItemIndex] := Item.Name;
  end;
end;

procedure TUserToolForm.SpTBXButton5Click(Sender: TObject);
begin
  if UserToolBox.ItemIndex = -1 then
    Exit;
  TObject(UserToolBox.Items.Objects[UserToolBox.ItemIndex]).Free;
  UserToolBox.Items.Delete(UserToolBox.ItemIndex);
end;

procedure TUserToolForm.SpTBXButton8Click(Sender: TObject);
begin
  if po <> nil then
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/2005127221748468.htm'),HH_DISPLAY_TOC,0);
end;

procedure TUserToolForm.SpTBXButton6Click(Sender: TObject);
begin
  ForceDirectories(ExtractFilePath(Application.ExeName) + 'Settings');
  SaveToCustomTool(ExtractFilePath(Application.ExeName) + 'Settings\tools.db');
end;

procedure TUserToolForm.FormCreate(Sender: TObject);
begin
  LoadFromCustomTool(
    ExtractFilePath(Application.ExeName) + 'Settings\tools.db');
end;

procedure TUserToolForm.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to UserToolBox.Items.Count-1 do
    TObject(UserToolBox.Items.Objects[i]).Free;
end;

procedure TUserToolForm.SpTBXButton3Click(Sender: TObject);
var
  tmpobj: TObject;
  t: String;
begin
  if (UserToolBox.ItemIndex = 0) or (UserToolBox.ItemIndex = -1) then
    Exit;

  tmpobj := UserToolBox.Items.Objects[UserToolBox.ItemIndex-1];
  t := UserToolBox.Items[UserToolBox.ItemIndex-1];
  UserToolBox.Items.Objects[UserToolBox.ItemIndex-1] :=
    UserToolBox.Items.Objects[UserToolBox.ItemIndex];
  UserToolBox.Items[UserToolBox.ItemIndex-1] :=
    UserToolBox.Items[UserToolBox.ItemIndex];
  UserToolBox.Items.Objects[UserToolBox.ItemIndex] := tmpobj;
  UserToolBox.Items[UserToolBox.ItemIndex] := t;
  UserToolBox.ItemIndex := UserToolBox.ItemIndex - 1;
end;

procedure TUserToolForm.SpTBXButton4Click(Sender: TObject);
var
  tmpobj: TObject;
  t: String;
begin
  if (UserToolBox.ItemIndex = UserToolBox.Count-1) or
    (UserToolBox.ItemIndex = -1) then
    Exit;

  tmpobj := UserToolBox.Items.Objects[UserToolBox.ItemIndex+1];
  t := UserToolBox.Items[UserToolBox.ItemIndex+1];
  UserToolBox.Items.Objects[UserToolBox.ItemIndex+1] :=
    UserToolBox.Items.Objects[UserToolBox.ItemIndex];
  UserToolBox.Items[UserToolBox.ItemIndex+1] :=
    UserToolBox.Items[UserToolBox.ItemIndex];
  UserToolBox.Items.Objects[UserToolBox.ItemIndex] := tmpobj;
  UserToolBox.Items[UserToolBox.ItemIndex] := t;
  UserToolBox.ItemIndex := UserToolBox.ItemIndex + 1;
end;

procedure TUserToolForm.ApplicationEventsIdle(Sender: TObject;
  var Done: Boolean);
begin
  SpTBXButton2.Enabled := (UserToolBox.ItemIndex <> -1);
  SpTBXButton5.Enabled := (UserToolBox.ItemIndex <> -1);
  SpTBXButton3.Enabled :=
    (UserToolBox.ItemIndex <> 0) and (UserToolBox.ItemIndex <> -1);
  SpTBXButton4.Enabled := (UserToolBox.ItemIndex <> UserToolBox.Count-1) and
    (UserToolBox.ItemIndex <> -1);
end;

procedure TUserToolForm.UserToolBoxDblClick(Sender: TObject);
begin
  SpTBXButton2Click(nil);
end;

procedure TUserToolForm.UserToolBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //wih
  if odSelected in State then
  begin
    TListBox(Control).Canvas.Brush.Color := clMenuHighlight;
    TListBox(Control).Canvas.FillRect(Rect);
  end else
  begin
    TListBox(Control).Canvas.Brush.Color := clWindow;
    TListBox(Control).Canvas.FillRect(Rect);
  end;

  FormMain.MenuImageList.Draw(TListBox(Control).Canvas,
    1, Rect.Top + 2, 60);

  //̕`
  TListBox(Control).Canvas.TextOut(20,Rect.Top + 3,
    TListBox(Control).Items[Index]);
end;

end.
