unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, TB2Item, TBX, SpTBXItem, TB2Dock, TB2Toolbar,
  TBXDkPanels, SpTBXDkPanels, StdCtrls, SpTBXTabs,
  TB2ToolWindow, TBXSwitcher, ComCtrls, ExtCtrls, OleCtrls, SHDocVw_TLB,
  TKWebBrowser, ActiveX, ImgList, Menus, TB2ExtItems,
  SpTBXEditors, ShellAPI, TTKMouseGestures, TBXStatusBars, AppEvnts,
  SynEdit, SynEditHighlighter, SynHighlighterHtml, SynEditTypes,
  SynEditMiscClasses, SynEditSearch, Math;

type
  HH_POPUP = record
    cdStruct: Integer;
    hInst: Cardinal;
    idString: Integer;
    pszText: PChar;
    pt: TPoint;
    clrForeground: Integer;
    clrBackground: Integer;
    rcMargins: TRect;
    pszFont: PChar;
  end;

type
  HH_FTS_QUERY = record
    cbStruct: Integer;
    fUniCodeStrings: Boolean;
    pszSearchQuery: PChar;
    iProximity: LongInt;
    fStemmedSearch: Boolean;
    fTitleOnly: Boolean;
    fExecute: Boolean;
    pszWindow: PChar;
  end;

const
  HT_HTMLHelp = 0;
  HT_JAVAHelp = 1;
  HT_HTMLHelp2 = 2;

const
  HH_DISPLAY_TOPIC = $0000;
  HH_HELP_FINDER = $0000;
  HH_DISPLAY_TOC = $0001;
  HH_DISPLAY_INDEX = $0002;
  HH_DISPLAY_SEARCH = $0003;
  HH_SET_WIN_TYPE = $0004;
  HH_GET_WIN_TYPE = $0005;
  HH_GET_WIN_HANDLE = $0006;
  HH_ENUM_INFO_TYPE = $0007;
  HH_SET_INFO_TYPE = $0008;
  HH_SYNC = $0009;
  HH_RESERVED1 = $000A;
  HH_RESERVED2 = $000B;
  HH_RESERVED3 = $000C;
  HH_KEYWORD_LOOKUP = $000D;
  HH_DISPLAY_TEXT_POPUP = $000E;
  HH_HELP_CONTEXT = $000F;
  HH_TP_HELP_CONTEXTMENU = $0010;
  HH_TP_HELP_WM_HELP = $0011;
  HH_CLOSE_ALL = $0012;
  HH_ALINK_LOOKUP = $0013;
  HH_GET_LAST_ERROR = $0014;
  HH_ENUM_CATEGORY = $0015;
  HH_ENUM_CATEGORY_IT = $0016;
  HH_RESET_IT_FILTER = $0017;
  HH_SET_INCLUSIVE_FILTER = $0018;
  HH_SET_EXCLUSIVE_FILTER = $0019;
  HH_INITIALIZE = $001C;
  HH_UNINITIALIZE = $001D;
  HH_PRETRANSLATEMESSAGE = $00fd;
  HH_SET_GLOBAL_PROPERTY = $00fc;

type
  TTopicType = (TTPBook, TTPItem, TTPMarge);
  TTopicItem = class
    TopicType: TTopicType;
    Name: String;
    Key: String;
    Path: String;
    ID: String;
    IDNum: String;
    FBookEdit: Boolean;
    FImageIndex: Integer;
    Date: String; //{
  end;

type
  TUserToolitem = class
    Name: String;
    Path: String;
  end;

const
  KeyID_AllCapt = 5484;
  KeyID_WndCapt = 5485;
  KeyID_BoxCapt = 5486;
  KeyID_ControlCapt = 5487;

type
  TFormMain = class(TForm)
    SpTBXDock1: TSpTBXDock;
    SpTBXToolbar1: TSpTBXToolbar;
    ActionList1: TActionList;
    SpTBXSubmenuItem1: TSpTBXSubmenuItem;
    aacNewProject: TAction;
    SpTBXItem1: TSpTBXItem;
    SpTBXMultiDock1: TSpTBXMultiDock;
    SpTBXMultiDock2: TSpTBXMultiDock;
    SpTBXMultiDock3: TSpTBXMultiDock;
    SpTBXMultiDock4: TSpTBXMultiDock;
    TBXSwitcher1: TTBXSwitcher;
    TBXDockablePanel1: TTBXDockablePanel;
    TBXDockablePanel2: TTBXDockablePanel;
    OutLogList: TListBox;
    ContentTree: TTreeView;
    TBXAlignmentPanel1: TTBXAlignmentPanel;
    SpTBXDock2: TSpTBXDock;
    SpTBXToolbar2: TSpTBXToolbar;
    aacNewTopic: TAction;
    SpTBXItem2: TSpTBXItem;
    EditorPanel: TPanel;
    EditorTabs: TSpTBXTabControl;
    SpTBXTabItem1: TSpTBXTabItem;
    SpTBXTabSheet1: TSpTBXTabSheet;
    SpTBXTabItem2: TSpTBXTabItem;
    SpTBXTabSheet2: TSpTBXTabSheet;
    PreViewBrowser: TTKWebBrowser;
    EditBrowser: TTKWebBrowser;
    aacOpenProject: TAction;
    aacSaveProject: TAction;
    SpTBXSeparatorItem1: TSpTBXSeparatorItem;
    SpTBXItem3: TSpTBXItem;
    SpTBXItem4: TSpTBXItem;
    OpenDialogProject: TOpenDialog;
    aacDelTopic: TAction;
    aacNewHeader: TAction;
    SpTBXItem5: TSpTBXItem;
    TreeNodeImages: TImageList;
    MenuImageList: TImageList;
    SpTBXSeparatorItem2: TSpTBXSeparatorItem;
    SpTBXItem6: TSpTBXItem;
    aaEditTopic: TAction;
    SpTBXItem7: TSpTBXItem;
    SpTBXSeparatorItem3: TSpTBXSeparatorItem;
    aaUp: TAction;
    aaDown: TAction;
    aaRight: TAction;
    aaLeft: TAction;
    SpTBXSeparatorItem4: TSpTBXSeparatorItem;
    SpTBXItem8: TSpTBXItem;
    SpTBXItem9: TSpTBXItem;
    SpTBXItem10: TSpTBXItem;
    SpTBXItem11: TSpTBXItem;
    aacExport: TAction;
    SpTBXSeparatorItem5: TSpTBXSeparatorItem;
    SpTBXItem12: TSpTBXItem;
    SpTBXSeparatorItem6: TSpTBXSeparatorItem;
    SpTBXItem13: TSpTBXItem;
    aacExit: TAction;
    SpTBXSubmenuItem2: TSpTBXSubmenuItem;
    aacUndo: TAction;
    aacRedo: TAction;
    aacCopy: TAction;
    aacCut: TAction;
    aacPaste: TAction;
    aacDelete: TAction;
    aacSelectAll: TAction;
    SpTBXItem14: TSpTBXItem;
    SpTBXItem15: TSpTBXItem;
    SpTBXItem16: TSpTBXItem;
    SpTBXItem17: TSpTBXItem;
    SpTBXItem18: TSpTBXItem;
    SpTBXItem19: TSpTBXItem;
    SpTBXItem20: TSpTBXItem;
    SpTBXItem21: TSpTBXItem;
    SpTBXSeparatorItem7: TSpTBXSeparatorItem;
    SpTBXSeparatorItem8: TSpTBXSeparatorItem;
    SpTBXSeparatorItem9: TSpTBXSeparatorItem;
    SpTBXItem22: TSpTBXItem;
    SpTBXItem23: TSpTBXItem;
    aacFind: TAction;
    aacFindNext: TAction;
    aacRep: TAction;
    SpTBXSeparatorItem10: TSpTBXSeparatorItem;
    EditorPopup: TSpTBXPopupMenu;
    SpTBXSubmenuItem3: TSpTBXSubmenuItem;
    aaLink: TAction;
    aaImage: TAction;
    aaLine: TAction;
    aaBookMark: TAction;
    aaEditFont: TAction;
    aaBold: TAction;
    aaItalic: TAction;
    aaUnderLine: TAction;
    aaStrikOut: TAction;
    aaList: TAction;
    aaNumList: TAction;
    aaCustomTag: TAction;
    SpTBXItem24: TSpTBXItem;
    SpTBXItem25: TSpTBXItem;
    SpTBXItem26: TSpTBXItem;
    SpTBXSeparatorItem11: TSpTBXSeparatorItem;
    SpTBXItem27: TSpTBXItem;
    SpTBXSeparatorItem12: TSpTBXSeparatorItem;
    SpTBXItem28: TSpTBXItem;
    SpTBXItem29: TSpTBXItem;
    SpTBXItem30: TSpTBXItem;
    SpTBXItem31: TSpTBXItem;
    SpTBXItem32: TSpTBXItem;
    SpTBXSeparatorItem13: TSpTBXSeparatorItem;
    SpTBXItem33: TSpTBXItem;
    SpTBXItem34: TSpTBXItem;
    SpTBXItem35: TSpTBXItem;
    SpTBXSeparatorItem14: TSpTBXSeparatorItem;
    aaLeftYose: TAction;
    aaCenterYose: TAction;
    aaRightYose: TAction;
    SpTBXSeparatorItem15: TSpTBXSeparatorItem;
    SpTBXItem36: TSpTBXItem;
    SpTBXItem37: TSpTBXItem;
    SpTBXItem38: TSpTBXItem;
    SpTBXSubmenuItem4: TSpTBXSubmenuItem;
    aacCapture: TAction;
    SpTBXItem39: TSpTBXItem;
    PopupMenu1: TPopupMenu;
    aaIndent: TAction;
    aaUnIndent: TAction;
    SpTBXSeparatorItem16: TSpTBXSeparatorItem;
    SpTBXItem40: TSpTBXItem;
    SpTBXItem41: TSpTBXItem;
    aacSourceEdit: TAction;
    SpTBXSeparatorItem17: TSpTBXSeparatorItem;
    SpTBXItem43: TSpTBXItem;
    CapturePopup: TPopupMenu;
    AllCapture: TMenuItem;
    BoxCapture: TMenuItem;
    ControlCapture: TMenuItem;
    WndCapture: TMenuItem;
    N5: TMenuItem;
    CaptureEnd: TMenuItem;
    aacOption: TAction;
    SpTBXSeparatorItem18: TSpTBXSeparatorItem;
    SpTBXItem45: TSpTBXItem;
    aaContextIDMap: TAction;
    SpTBXItem44: TSpTBXItem;
    aacCompile: TAction;
    SpTBXSubmenuItem5: TSpTBXSubmenuItem;
    SpTBXItem46: TSpTBXItem;
    aacRun: TAction;
    SpTBXItem47: TSpTBXItem;
    aaSettingProject: TAction;
    SpTBXSeparatorItem19: TSpTBXSeparatorItem;
    SpTBXItem48: TSpTBXItem;
    SpTBXSubmenuItem6: TSpTBXSubmenuItem;
    SpTBXItem49: TSpTBXItem;
    aacHTMLHelpAPI: TAction;
    aaDeleteFormat: TAction;
    SpTBXItem50: TSpTBXItem;
    RetProjectSubMenu: TSpTBXSubmenuItem;
    aacHelp: TAction;
    aacWeb: TAction;
    aacTutorial: TAction;
    aacVarInfo: TAction;
    SpTBXItem51: TSpTBXItem;
    SpTBXItem52: TSpTBXItem;
    SpTBXSeparatorItem20: TSpTBXSeparatorItem;
    SpTBXItem53: TSpTBXItem;
    SpTBXSeparatorItem21: TSpTBXSeparatorItem;
    SpTBXItem54: TSpTBXItem;
    ContentPopup: TSpTBXPopupMenu;
    SpTBXItem55: TSpTBXItem;
    SpTBXItem56: TSpTBXItem;
    SpTBXSeparatorItem22: TSpTBXSeparatorItem;
    SpTBXItem57: TSpTBXItem;
    SpTBXSeparatorItem23: TSpTBXSeparatorItem;
    SpTBXItem58: TSpTBXItem;
    SpTBXItem59: TSpTBXItem;
    SpTBXItem60: TSpTBXItem;
    SpTBXItem61: TSpTBXItem;
    SpTBXSeparatorItem24: TSpTBXSeparatorItem;
    SpTBXItem62: TSpTBXItem;
    TBXSwitcher2: TTBXSwitcher;
    SpTBXToolbar5: TSpTBXToolbar;
    SpTBXItem63: TSpTBXItem;
    SpTBXItem65: TSpTBXItem;
    SpTBXItem66: TSpTBXItem;
    SpTBXSeparatorItem25: TSpTBXSeparatorItem;
    SpTBXSeparatorItem26: TSpTBXSeparatorItem;
    SpTBXSeparatorItem27: TSpTBXSeparatorItem;
    SpTBXItem69: TSpTBXItem;
    SpTBXSeparatorItem29: TSpTBXSeparatorItem;
    SpTBXItem70: TSpTBXItem;
    SpTBXItem71: TSpTBXItem;
    SpTBXItem72: TSpTBXItem;
    SpTBXSeparatorItem30: TSpTBXSeparatorItem;
    SpTBXItem73: TSpTBXItem;
    SpTBXSeparatorItem31: TSpTBXSeparatorItem;
    SpTBXItem74: TSpTBXItem;
    TTKMouseGestures: TTTKMouseGestures;
    TBXStatusBar1: TTBXStatusBar;
    ActiveEditFileEditor: TSpTBXEdit;
    ApplicationEvents1: TApplicationEvents;
    SpTBXDock4: TSpTBXDock;
    SpTBXDock5: TSpTBXDock;
    SpTBXDock6: TSpTBXDock;
    aacInsertTable: TAction;
    SpTBXItem42: TSpTBXItem;
    aacUserTool: TAction;
    SpTBXItem75: TSpTBXItem;
    SpTBXSubmenuItem8: TSpTBXSubmenuItem;
    UserToolSubMenu: TSpTBXSubmenuItem;
    SpTBXToolbar7: TSpTBXToolbar;
    SpTBXItem67: TSpTBXItem;
    SpTBXItem68: TSpTBXItem;
    SpTBXSubmenuItem10: TSpTBXSubmenuItem;
    SpTBXTabItem3: TSpTBXTabItem;
    SpTBXTabSheet3: TSpTBXTabSheet;
    SpTBXDock3: TSpTBXDock;
    SpTBXToolbar3: TSpTBXToolbar;
    SpTBXToolbar4: TSpTBXToolbar;
    SpTBXToolbar6: TSpTBXToolbar;
    SpHBox: TSpTBXComboBoxItem;
    Editor: TSynEdit;
    SynHTMLSyn: TSynHTMLSyn;
    SynEditSearch: TSynEditSearch;
    procedure aacNewProjectExecute(Sender: TObject);
    procedure aacNewTopicExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ContentTreeDblClick(Sender: TObject);
    procedure EditorTabsActiveTabChange(Sender: TObject;
      ItemIndex: Integer);
    procedure PreViewBrowserNavigateComplete2(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure EditBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure aacOpenProjectExecute(Sender: TObject);
    procedure aacSaveProjectExecute(Sender: TObject);
    procedure PreViewBrowserNewWindow2(Sender: TObject;
      var ppDisp: IDispatch; var Cancel: WordBool);
    procedure aacNewHeaderExecute(Sender: TObject);
    procedure aacDelTopicExecute(Sender: TObject);
    procedure aaEditTopicExecute(Sender: TObject);
    procedure ContentTreeEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure aaUpExecute(Sender: TObject);
    procedure aaDownExecute(Sender: TObject);
    procedure aaLeftExecute(Sender: TObject);
    procedure aaRightExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure aacExitExecute(Sender: TObject);
    procedure aacUndoExecute(Sender: TObject);
    procedure aacRedoExecute(Sender: TObject);
    procedure aacCopyExecute(Sender: TObject);
    procedure aacCutExecute(Sender: TObject);
    procedure aacPasteExecute(Sender: TObject);
    procedure aacDeleteExecute(Sender: TObject);
    procedure aacSelectAllExecute(Sender: TObject);
    procedure aacFindExecute(Sender: TObject);
    procedure aacFindNextExecute(Sender: TObject);
    procedure aacRepExecute(Sender: TObject);
    procedure aaLinkExecute(Sender: TObject);
    procedure aaImageExecute(Sender: TObject);
    procedure aaLineExecute(Sender: TObject);
    procedure aaBookMarkExecute(Sender: TObject);
    procedure aaBoldExecute(Sender: TObject);
    procedure aaItalicExecute(Sender: TObject);
    procedure aaUnderLineExecute(Sender: TObject);
    procedure aaListExecute(Sender: TObject);
    procedure aaNumListExecute(Sender: TObject);
    procedure aaLeftYoseExecute(Sender: TObject);
    procedure aaCenterYoseExecute(Sender: TObject);
    procedure aaRightYoseExecute(Sender: TObject);
    procedure aaIndentExecute(Sender: TObject);
    procedure aaUnIndentExecute(Sender: TObject);
    procedure aaStrikOutExecute(Sender: TObject);
    procedure aaEditFontExecute(Sender: TObject);
    procedure aaCustomTagExecute(Sender: TObject);
    procedure aacCaptureExecute(Sender: TObject);
    procedure CaptureEndClick(Sender: TObject);
    procedure AllCaptureClick(Sender: TObject);
    procedure WndCaptureClick(Sender: TObject);
    procedure BoxCaptureClick(Sender: TObject);
    procedure ControlCaptureClick(Sender: TObject);
    procedure aacSourceEditExecute(Sender: TObject);
    procedure aacExportExecute(Sender: TObject);
    procedure aacOptionExecute(Sender: TObject);
    procedure aacCompileExecute(Sender: TObject);
    procedure aacRunExecute(Sender: TObject);
    procedure aaContextIDMapExecute(Sender: TObject);
    procedure aacHTMLHelpAPIExecute(Sender: TObject);
    procedure aaDeleteFormatExecute(Sender: TObject);
    procedure RetProjectSubMenuPopup(Sender: TTBCustomItem;
      FromLink: Boolean);
    procedure ContentPopupPopup(Sender: TObject);
    procedure aaSettingProjectExecute(Sender: TObject);
    procedure aacHelpExecute(Sender: TObject);
    procedure aacTutorialExecute(Sender: TObject);
    procedure aacWebExecute(Sender: TObject);
    procedure aacVarInfoExecute(Sender: TObject);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure ContentTreeDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ContentTreeDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SpHBoxChange(Sender: TObject;
      const Text: WideString);
    procedure EditBrowserEnter(Sender: TObject);
    procedure TTKMouseGesturesGestureEnd(Sender: TObject);
    procedure TTKMouseGesturesGestureExec(Sender: TObject);
    procedure TTKMouseGesturesGestureProgress(Sender: TObject;
      const GestureStr, KeyGesture: String);
    procedure TTKMouseGesturesGestureStart(Sender: TObject;
      var Cancel: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure aacInsertTableExecute(Sender: TObject);
    procedure UserToolSubMenuPopup(Sender: TTBCustomItem;
      FromLink: Boolean);
    procedure aacUserToolExecute(Sender: TObject);
    procedure EditorChange(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
    procedure ContentTreeKeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
    FFindDialog: TForm;
    FOnEditFlag: Boolean; //ҏWTrue
    FDeleteTempList: TStringList;
    FActiveEditDate: TTopicItem;
    FActiveEditTreeNode: TTreeNode;
    NID : TNotifyIconData;
    procedure AllWndCapt(BMP: TBitMap);
    procedure ActWndCapt(BMP: TBitMap);
    function ControlCapt(BMP: TBitMap): Boolean;
    function BoxWndCapt(BMP,BM2: TBitMap): Boolean;
    procedure WMUSER(var Msg : TMsg); message WM_USER + 5458;
    procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;
    procedure FreeTempList;
    procedure AddNodeTopic(Types: TTopicType;
      const Name,Key,Context,NumId: String;
      child: Boolean; ImageIndex: Integer);
    procedure SaveToolBarsPos(const Path: String);
    procedure ReadToolBarsPos(const Path: String);
  public
    { Public 錾 }
    FPrevTabIndex: Integer;

    FReOpenList: TStringList;
    FProjectHelpType: Integer; //0MSHTML1,1JavaHelp,2MSHTML2
    FProjectContextIDInc: Integer;
    FProjectFullPath: String;
    FProjectPathName: String;
    FProjectTheme: String;
    FProjectWeb: String;
    FProjectCopyRight: String;
    FProjectTopPage: String;
    FProjectTitle: String;
    FProjectDepName: String;
    FProjectGenNameTitle: Boolean;
    FCompileMode: Boolean;
    FGestureMode: Boolean;
    FProjectdeploy: String;
    FDexpPath: String;

    FHSView: String;
    FJAR: String;
    FHTMLCompDir: String;
    FHTMLHelpCompiler: String;
    FBodyEditorPath: String;
    FNoCloseInfo: Boolean;
    FNoEndCapture: Boolean; 

    function GetTempDirName(Ext: String): String;
    function GetBodyHTML: String;
    procedure AllFreeTree;
    procedure LoadFormProject(const Path: String);
    procedure SaveToContents(const Path: String);
    procedure SaveToProject(const Path: String);
    procedure LoadFromContents(const FileName: String);
    function GenMagicNumber: String;
    function CreateTempName(Dir: String; Ext: String = ''): String;
    function ConvartConst(const Str: String; Node: TTopicItem;
      TreeNode: TTreeNode): String;
    function ConvCMD(const Command: String; var Edit: String;
      StartPos, EndPos: Integer; Node: TTopicItem;
      TreeNode: TTreeNode): Integer;
    procedure SetImage(Node: TTreeNode);
    procedure MainWndForg;
    function SelectDirectory2(Handle: THandle; const Caption: string;
      const Root: String; var Directory: string): Boolean;
    procedure OnReOpen(Sender: TObject);
    procedure UserToolOpen(Sender: TObject);
    procedure AllFreeUserTool;

    procedure ExportCHMProject(const ExpDir: String);
      procedure ExportHHC(const FileName: String);
      procedure ExportHHK(const FileName: String);
      procedure ExportHHP(const FileName: String);
      procedure ExportHTM(const DirName: String);
      function ReadDate(const Path: String): String;

    procedure ExportJavaHelpProject(const ExpDir: String);
      procedure ExportJHelpSet(const FileName: String);
      procedure ExportJToc(const FileName: String);
      procedure ExportJMap(const FileName: String);
      procedure ExportJHelpIndex(const FileName: String);

    procedure ExportHsXProject(const ExpDir: String);
      procedure ExportHsXHxC(const FileName: String); //HxCfo
      procedure ExportHsXToc(const FileName: String); //HxTfo
      procedure ExportHsXKey(const FileName: String); //HxKfo
      procedure ExportHsXMap(const FileName: String); //HxFfo

    procedure ReadIni;

    procedure UpdateControlEna;
  end;

var
  FormMain: TFormMain;
  po :TFarProc;
  DLLWnd :THandle;
  HtmlHelp:function(hwndCaller:Integer;pszFile:PChar;uCommand:Integer;dwData:Integer):Integer;stdcall;

implementation

uses FormNewWizard, FormNewTopic, IniFiles, MSHTML_TLB, FormFindDialog,
  FormReplace, FormLinkEditor, FormImageAddForm, FormFont,
  FormCustomTag, FormCaptureTool, FormSetCapture, FormControlCapt,
  FormBodySourceEdit, ShlObj, FormOption, FormContextIDEditor, APITestWnd,
  FormSetProject, FormVar, FormTableInsert, FormUserTool;

{$R *.dfm}

  function SelectDirectory2CallbackProc(
    hWnd: HWND; uMsg: UINT; lParam: LPARAM; lpData: LPARAM): integer; stdcall;
  begin
    case uMsg of
    BFFM_INITIALIZED:
      begin
        SendMessage(hWnd, BFFM_SETSELECTION, WPARAM(True), lpData);
      end;
    end;
    Result := 0;
  end;

  function TFormMain.ReadDate(const Path: String): String;
  var
    List,AddList: TStringList;
    i,x: integer;
  begin
    List := TStringList.Create;
    AddList := TStringList.Create;
    try
      List.LoadFromFile(Path);
      for i := 0 to List.Count-1 do
      begin
        if List[i] = '[Date]' then
        begin
          for x := i + 1 to List.Count-1 do
          begin
            AddList.Add(List[x]);
          end;
          Result := AddList.Text;
          Exit;
        end;
      end;
    finally
      AddList.Free;
      List.Free;
    end;
  end;

  procedure TFormMain.OnReOpen(Sender: TObject);
  begin
    if FileExists(TSpTBXItem(Sender).Hint) then
    begin
      LoadFormProject(TSpTBXItem(Sender).Hint);
    end;
  end;


  function TFormMain.SelectDirectory2(Handle: THandle; const Caption: string;
    const Root: String; var Directory: string): Boolean;
  var
    bfi: TBROWSEINFO;
    itmlist: PITEMIDLIST;
    ppc: array [0..32767] of Char;
  begin
    Result := False;
    CoInitialize(nil);
    try
      FillChar(bfi,Sizeof(bfi),0);
      bfi.hwndOwner := Handle;
      bfi.pidlRoot := nil;
      bfi.pszDisplayName := ppc;
      bfi.lpszTitle := PChar(Caption);
      bfi.ulFlags := BIF_RETURNONLYFSDIRS or $0040;
      bfi.lpfn := @SelectDirectory2CallbackProc;
      bfi.lParam := Integer(PChar(Root));
      bfi.iImage := 0;

      itmlist := SHBrowseForFolder(bfi);
      if itmlist <> nil then
      begin
        SHGetPathFromIDList(itmlist,@ppc);
        Directory := ppc;
        CoTaskMemFree(itmlist);
        Result := True;
      end;
    finally
      CoUninitialize;
    end;
  end;

  procedure TFormMain.ReadToolBarsPos(const Path: String);
    function FindTBDock(const Name: String): TTBDock;
    var
      i: integer;
    begin
      Result := nil;
      if Name = '' then
        Exit;
      for i := 0 to ComponentCount-1 do
      begin
        if Components[i].Name = Name then
        begin
          Result := TTBDock(Components[i]);
          Break;
        end;
      end;
    end;
  var
    i: integer;
    ini: TMemIniFile;
    Tp: TPoint;
  begin
    if FileExists(Path) = False then
      Exit;

    ini := TMemIniFile.Create(Path);
    try
      for i := 0 to ComponentCount-1 do
      begin
        if Components[i] is TTBXToolBar then
        begin
          with TTBXToolBar(Components[i]) do
          begin
            BeginUpdate;
            try
              Tp.Y := ini.ReadInteger(Name,'FlortY',FloatingPosition.Y);
              Tp.X := ini.ReadInteger(Name,'FlortX',FloatingPosition.X);
              FloatingPosition := Tp;
              FloatingWidth := ini.ReadInteger(Name,'FloatW',FloatingWidth);
              Width := ini.ReadInteger(Name,'Width',Width);
              Height := ini.ReadInteger(Name,'Height',Height);
              DockRow := ini.ReadInteger(Name,'Row',DockRow);
              DockPos := ini.ReadInteger(Name,'Pos',DockPos);
              if CurrentDock <> nil then
                CurrentDock := FindTBDock(
                  ini.ReadString(Name,'DockName',CurrentDock.Name)) else
                CurrentDock := FindTBDock(
                  ini.ReadString(Name,'DockName',''));
              Floating := ini.ReadBool(Name,'Float',Floating);
              Visible := ini.ReadBool(Name,'Visible',Visible);
            finally
              EndUpdate;
            end;
          end;
        end;

        if Components[i] is TTBXDockablePanel then
        begin
          with TTBXDockablePanel(Components[i]) do
          begin
            BeginUpdate;
            try
              Floating := ini.ReadBool(Name,'Float',Floating);
              if CurrentDock <> nil then
              begin
                CurrentDock := FindTBDock(
                  ini.ReadString(Name,'DockName',CurrentDock.Name));
              end;
              Tp.Y := ini.ReadInteger(Name,'FlortY',FloatingPosition.Y);
              Tp.X := ini.ReadInteger(Name,'FlortX',FloatingPosition.X);
              FloatingPosition := Tp;
              FloatingWidth := ini.ReadInteger(Name,'FloatW',FloatingWidth);
              FloatingHeight := ini.ReadInteger(Name,'FloatH',FloatingHeight);
              SplitHeight := ini.ReadInteger(Name,'SplitHeight',SplitHeight);
              SplitWidth := ini.ReadInteger(Name,'SplitWidth',SplitWidth);
              Width := ini.ReadInteger(Name,'Width',Width);
              Height := ini.ReadInteger(Name,'Height',Height);
              DockRow := ini.ReadInteger(Name,'Row',DockRow);
              DockPos := ini.ReadInteger(Name,'Pos',DockPos);
              Visible := ini.ReadBool(Name,'Visible',Visible);
            finally
              EndUpdate;
            end;
          end;
        end;

        if Components[i] is TTBXToolWindow then
        begin
          with TTBXToolWindow(Components[i]) do
          begin
            BeginUpdate;
            try
              Floating := ini.ReadBool(Name,'Float',Floating);
              Tp.Y := ini.ReadInteger(Name,'FlortY',FloatingPosition.Y);
              Tp.X := ini.ReadInteger(Name,'FlortX',FloatingPosition.X);
              FloatingPosition := Tp;
              Width := ini.ReadInteger(Name,'Width',Width);
              Height := ini.ReadInteger(Name,'Height',Height);
              DockRow := ini.ReadInteger(Name,'Row',DockRow);
              DockPos := ini.ReadInteger(Name,'Pos',DockPos);
              if CurrentDock <> nil then
                CurrentDock := FindTBDock(
                  ini.ReadString(Name,'DockName',CurrentDock.Name));
              Visible := ini.ReadBool(Name,'Visible',Visible);
            finally
              EndUpdate;
            end;
          end;
        end;
      end;

      //c[o[ȊȌf[^
      Top := ini.ReadInteger('Wnd','Top',Top);
      Left := ini.ReadInteger('Wnd','Left',Left);
      Width := ini.ReadInteger('Wnd','Width',Width);
      Height := ini.ReadInteger('Wnd','Height',Height);
    finally
      ini.Free;
    end;
  end;

  procedure TFormMain.SaveToolBarsPos(const Path: String);
  var
    i: integer;
    ini: TMemIniFile;
  begin
    ini := TMemIniFile.Create(Path);
    try
      for i := 0 to ComponentCount-1 do
      begin
        if Components[i] is TTBXToolBar then
        begin
          with TTBXToolBar(Components[i]) do
          begin
            ini.WriteInteger(Name,'FlortY',FloatingPosition.Y);
            ini.WriteInteger(Name,'FlortX',FloatingPosition.X);
            ini.WriteBool(Name,'Float',Floating);
            ini.WriteInteger(Name,'FloatW',FloatingWidth);
            ini.WriteInteger(Name,'Width',Width);
            ini.WriteInteger(Name,'Height',Height);
            ini.WriteInteger(Name,'Row',DockRow);
            ini.WriteInteger(Name,'Pos',DockPos);
            if CurrentDock <> nil then
              ini.WriteString(Name,'DockName',CurrentDock.Name) else
              ini.WriteString(Name,'DockName','');
            ini.WriteBool(Name,'Visible',Visible);
          end;
        end;

        if Components[i] is TTBXDockablePanel then
        begin
          with TTBXDockablePanel(Components[i]) do
          begin
            ini.WriteInteger(Name,'FlortY',FloatingPosition.Y);
            ini.WriteInteger(Name,'FlortX',FloatingPosition.X);
            ini.WriteInteger(Name,'SplitWidth',SplitWidth);
            ini.WriteInteger(Name,'SplitHeight',SplitHeight);
            ini.WriteBool(Name,'Float',not Docked);
            ini.WriteInteger(Name,'FloatW',FloatingWidth);
            ini.WriteInteger(Name,'Width',Width);
            ini.WriteInteger(Name,'Height',Height);
            ini.WriteInteger(Name,'Row',DockRow);
            ini.WriteInteger(Name,'Pos',DockPos);
            if CurrentDock <> nil then
              ini.WriteString(Name,'DockName',CurrentDock.Name) else
              ini.WriteString(Name,'DockName','');
            ini.WriteBool(Name,'Visible',Visible);
          end;
        end;

        if Components[i] is TTBXToolWindow then
        begin
          with TTBXToolWindow(Components[i]) do
          begin
            ini.WriteInteger(Name,'FlortY',FloatingPosition.Y);
            ini.WriteInteger(Name,'FlortX',FloatingPosition.X);
            ini.WriteBool(Name,'Float',not Docked);
            ini.WriteInteger(Name,'Width',Width);
            ini.WriteInteger(Name,'Height',Height);
            ini.WriteInteger(Name,'Row',DockRow);
            ini.WriteInteger(Name,'Pos',DockPos);
            if CurrentDock <> nil then
              ini.WriteString(Name,'DockName',CurrentDock.Name) else
              ini.WriteString(Name,'DockName','');
            ini.WriteBool(Name,'Visible',Visible);
          end;
        end;
      end;

      //c[o[ȊȌf[^
      ini.WriteInteger('Wnd','Top',Top);
      ini.WriteInteger('Wnd','Left',Left);
      ini.WriteInteger('Wnd','Width',Width);
      ini.WriteInteger('Wnd','Height',Height);

      ini.UpdateFile;
    finally
      ini.Free;
    end;
  end;

procedure TFormMain.ReadIni;
var
  ini: TMemIniFile;
  i: integer;
begin
  ini := TMemIniFile.Create(ExtractFilePath(Application.ExeName) +
    'Setting.ini');
  try
    FHTMLHelpCompiler :=
      ini.ReadString('Option','WorkShop','');
    FBodyEditorPath :=
      ini.ReadString('Option','BodyEditor','');
    FNoCloseInfo :=
      ini.ReadBool('Option','NoCloseInfo',False);
    FNoEndCapture :=
      ini.ReadBool('Option','NoEndCapture',False);

    FHSView := ini.ReadString('Option','hsviewer','');
    FJAR := ini.ReadString('Option','jar','');

    FHTMLCompDir :=
      ini.ReadString('Option','HTML2XDir','');

    for i := 0 to ComponentCount-1 do
    begin
      if Components[i] is TSpTBXToolBar then
      begin
        TTBXToolBar(Components[i]).SmoothDrag :=
          ini.ReadBool('Option','SmoothDrag',
            TTBXToolBar(Components[i]).SmoothDrag);
      end;
      if Components[i] is TSpTBXDockablePanel then
      begin
        TTBXDockablePanel(Components[i]).SmoothDrag :=
          ini.ReadBool('Option','SmoothDrag',
            TTBXToolBar(Components[i]).SmoothDrag);
        TTBXDockablePanel(Components[i]).SmoothDockedResize :=
          ini.ReadBool('Option','SmoothDock',
            TTBXToolBar(Components[i]).SmoothDrag);
      end;
    end;
    SpTBXMultiDock1.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXMultiDock2.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXMultiDock3.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXMultiDock4.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXDock1.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXDock4.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXDock5.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);
    SpTBXDock6.AllowDrag :=
      not ini.ReadBool('Option','FixToolbar',True);

    TBXSwitcher1.Theme := ini.ReadString('Option','TBXTheme','OfficeXP');

    TTKMouseGestures.Enabled := ini.ReadBool('Gesture','Ges',True);
    TTKMouseGestures.GestureLength :=
      ini.ReadInteger('Gesture','ItemNinsiki',40);

    FDexpPath := ini.ReadString('Option','Dexplorepath','');

    TTKMouseGestures.ClearGesture;
    for i := 0 to ActionList1.ActionCount-1 do
    begin
      if TAction(ActionList1[i]).Caption = '' then
        Continue;

      TAction(ActionList1[i]).ShortCut :=
        TextToShortCut(ini.ReadString('HotKey',
        TAction(ActionList1[i]).Category + '-' +
        TAction(ActionList1[i]).Caption,
        ShortCutToText(TAction(ActionList1[i]).ShortCut)));

      TTKMouseGestures.AddGesture(ini.ReadString('Gesture',
        TAction(ActionList1[i]).Category + '-' +
        TAction(ActionList1[i]).Caption,''),
        TAction(ActionList1[i]));
    end;
  finally
    ini.Free;
  end;
end;

procedure TFormMain.ExportHTM(const DirName: String);
var
  Sh: TSHFILEOPSTRUCT;
  sr: TSearchRec;
  ext, FSN: String;
  FilesList: TStringList;
  Nd: TTreeNode;

  List,AddList: TStringList;
begin
  //o͐悪łȂꍇ
  //܂̓vWFNgtH_̊gq.db,.tdb,.tag,.sprĵ̈ȊOSRs[
  if AnsiLowerCase(DirName) <>
    AnsiLowerCase(ExtractFileDir(FProjectFullPath)) then
  begin
    if FindFirst(ExtractFilePath(FProjectFullPath) + '*',
      faAnyFile, sr) = 0 then
    begin
      repeat
        if (sr.Name = '.') or (sr.Name = '..') then
          Continue;
        if (sr.Attr and faDirectory) <> 0 then
        begin
          //fBNg͑SRs[
          with Sh do
          begin
            Wnd := Application.Handle;
            wFunc := FO_COPY;
            pFrom := PChar(ExtractFilePath(FProjectFullPath) +
              sr.Name + #0 + #0);
            pTo:= PChar(DirName + '\' + sr.Name + #0 + #0);
            fFlags := FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR or
              FOF_NOERRORUI;
            hNameMappings := nil;
            lpszProgressTitle := nil;
          end;
          SHFileOperation(Sh);
        end else
        begin
          ext := AnsiLowerCase(ExtractFileExt(sr.Name));
          if (ext <> '.tdb') and (ext <> '.db') and (ext <> '.sprj')
            and (ext <> '.tag') then
          begin
            //t@CRs[
            CopyFile(PChar(ExtractFilePath(FProjectFullPath) + sr.Name),
              PChar(DirName + '\' + sr.Name),false);
          end;
        end;
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;
  end;

  //.db̃t@C͎ۂɃNĂ̂ϊ
  FilesList := TStringList.Create;
  List := TStringList.Create;
  AddList := TStringList.Create;
  try
    Nd := ContentTree.Items.GetFirstNode;
    while Nd <> nil do
    begin
      FSN := ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm');
      if FilesList.IndexOf(FSN) = -1 then
      begin
        FilesList.Add(FSN); //dp
        //e[}[h
          if FileExists(ExtractFilePath(FProjectFullPath) +
            FProjectTheme + '\header.htm') then
          List.LoadFromFile(ExtractFilePath(FProjectFullPath) +
            FProjectTheme + '\header.htm');
        //Body[h
          if FileExists(ExtractFilePath(FProjectFullPath) +
            TTopicItem(Nd.Data).Path) then
            AddList.Text := ReadDate(ExtractFilePath(FProjectFullPath) +
            TTopicItem(Nd.Data).Path);
          List.AddStrings(AddList);
        //e[}[h
          if FileExists(ExtractFilePath(FProjectFullPath) +
            FProjectTheme + '\footer.htm') then
          AddList.LoadFromFile(ExtractFilePath(FProjectFullPath) +
            FProjectTheme + '\footer.htm');
          List.AddStrings(AddList);
        //Ro[g
          List.Text := ConvartConst(List.Text,TTopicItem(Nd.Data),Nd);
        //ۑ
          List.SaveToFile(DirName + '\' + FSN);
      end;
      Nd := Nd.GetNext;
    end;
  finally
    FilesList.Free;
    AddList.Free;
    List.Free;
  end;
end;

procedure TFormMain.ExportHHP(const FileName: String);
var
  List, FilesList,MapList: TStringList;
  Nd: TTreeNode;
  FSN,Val: String;
begin
  List := TStringList.Create;
  FilesList := TStringList.Create;
  MapList := TStringList.Create;
  try
    List.Add('[OPTIONS]');
    List.Add('Auto Index=Yes');
    List.Add('Binary Index=Yes');
    List.Add('Compiled file=' + FProjectPathName + '.chm');
    List.Add('Contents file=' + FProjectPathName + '.hhc');
    List.Add('Index file=' + FProjectPathName + '.hhk');
    List.Add('Default Font=MS UI Gothic,10,128');
    List.Add('Default Window=defwnd');
    List.Add('Display compile progress=Yes');
    Val := FProjectTopPage;
    if Val <> '' then
    begin
      Val := ChangeFileExt(Val,'.htm');
      List.Add('Default topic=' + Val);
      Val := '"' + Val + '"';
    end;
    List.Add('Error log file=' + ChangeFileExt(FileName,'.log'));
    List.Add('Flat=No');
    List.Add('Full-text search=Yes');
    List.Add('Language=0x0411 Japanese');
    List.Add('Title=' + FProjectTitle);
    List.Add('');
    List.Add('[WINDOWS]');
    List.Add('defwnd="' + FProjectTitle +  '","' + FProjectPathName + '.hhc","' +
      FProjectPathName + '.hhk",'+ Val
      + ',,,,,,0x21720,200,0x10180E,' +
      '[380,211,944,656],0x1000000,0x0,,,,,0');
    List.Add('');
    List.Add('[FILES]');
    Nd := ContentTree.Items.GetFirstNode;
    while Nd <> nil do
    begin
      if TTopicItem(Nd.Data).TopicType = TTPItem then
      begin
        FSN := ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm');
        if FilesList.IndexOf(FSN) = -1 then
          FilesList.Add(FSN);
      end;
      Nd := Nd.GetNext;
    end;
    List.AddStrings(FilesList);
    FilesList.Clear;
    List.Add('');
    List.Add('[ALIAS]'); //󋵈ˑwṽGCAX
    Nd := ContentTree.Items.GetFirstNode;
    while Nd <> nil do
    begin
      if TTopicItem(Nd.Data).TopicType = TTPItem then
      begin
        if FilesList.IndexOf(TTopicItem(Nd.Data).Path) = -1 then
        begin
          //dp
          FilesList.Add(TTopicItem(Nd.Data).Path);

          List.Add(TTopicItem(Nd.Data).ID + '=' +
            ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm'));
          MapList.Add('#define ' + TTopicItem(Nd.Data).ID + ' ' +
            TTopicItem(Nd.Data).IDNum);
        end;
      end;
      Nd := Nd.GetNext;
    end;
    List.Add('');
    List.Add('[MAP]');
    MapList.SaveToFile(ChangeFileExt(FileName,'.h'));
    List.AddStrings(MapList);
    List.SaveToFile(FileName);
  finally
    MapList.Free;
    FilesList.Free;
    List.Free;
  end;
end;

procedure TFormMain.ExportHHC(const FileName: String);
  procedure AddTopicHTML(Node: TTreeNode; ls: TStringList);
  var
    t: TTopicItem;
  begin
    t := TTopicItem(Node.Data);
    ls.Add('<LI><OBJECT type="text/sitemap">');
      ls.Add('<param name="Name" value="' +
        t.Name + '">');
      case t.TopicType of
      TTPBook:
        begin
          ls.Add('<param name="ImageNumber" value="' +
            IntToStr(t.FImageIndex+1) + '">');
          if t.FBookEdit then
            ls.Add('<param name="Local" value="' +
              ChangeFileExt(t.Path,'.htm') + '">');
        end;
      TTPItem:
        begin
          ls.Add('<param name="ImageNumber" value="' +
             IntToStr(t.FImageIndex+1) + '">');
          ls.Add('<param name="Local" value="' +
            ChangeFileExt(t.Path,'.htm') + '">');
        end;
      end;
    ls.Add('</object>');
  end;
  procedure RoopTopicScan(Node: TTreeNode; ls: TStringList);
  var
    Nd: TTreeNode;
  begin
    //gsbN
    Nd := Node;
    while Nd <> nil do
    begin
      AddTopicHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        //qȂċA
        ls.Add('<UL>');
          RoopTopicScan(Nd.getFirstChild,ls);
        ls.Add('</UL>');
      end;
      Nd := Nd.GetNextSibling;
    end;
  end;
var
  ls: TStringList;
  Nd: TTreeNode;
begin
  ls := TStringList.Create;
  try
    ls.Add('<html>');
    ls.Add('<head>');
      ls.Add('<title>' + FProjectTitle + '</title>');
    ls.Add('</head>');
    ls.Add('<body>');
      ls.Add('<OBJECT type="text/site properties">');
        ls.Add('<param name="ImageType" value="Folder">');
        ls.Add('<param name="Window Styles" value="0x800027">');
      ls.Add('</OBJECT>');
      ls.Add('<UL>');
        //gsbN
        Nd := ContentTree.Items.GetFirstNode;
        while Nd <> nil do
        begin
          AddTopicHTML(Nd,ls);

          if Nd.HasChildren then
          begin
            //qȂċA
            ls.Add('<UL>');
              RoopTopicScan(Nd.getFirstChild,ls);
            ls.Add('</UL>');
          end;
          Nd := Nd.getNextSibling;
        end;
      ls.Add('</UL>');
    ls.Add('</body>');
    ls.Add('</html>');
    ls.SaveToFile(FileName);
  finally
    ls.Free;
  end;
end;

procedure TFormMain.ExportHHK(const FileName: String);
  procedure AddKeyHTML(Node: TTreeNode; ls: TStringList);
  var
    t: TTopicItem;
    ND: TTreeNode;
  begin
    t := TTopicItem(Node.Data);
    case t.TopicType of
    TTPBook:
      begin
        //̍ڂ̎qĒǉ
        Nd := Node.getFirstChild;
        if Nd <> nil then
        begin
          ls.Add('<LI><OBJECT type="text/sitemap">');
          ls.Add('<param name="Name" value="' + TTopicItem(Node.Data).Key +
            '">');
        end;
        while Nd <> nil do
        begin
          ls.Add('<param name="Name" value="' + TTopicItem(Nd.Data).Key +
            '">');
          ls.Add('<param name="Local" value="' +
            ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') +
            '">');
          Nd := Nd.getNextSibling;
        end;
        ls.Add('</OBJECT>');
      end;
    TTPItem:
      begin
        ls.Add('<LI><OBJECT type="text/sitemap">');
        ls.Add('<param name="Name" value="' + t.Key +
          '">');
        ls.Add('<param name="Local" value="' +
          ChangeFileExt(t.Path,'.htm') +
          '">');
        ls.Add('</OBJECT>');
      end;
    end;
  end;
  procedure RoopKeyScan(Node: TTreeNode; ls: TStringList);
  var
    Nd: TTreeNode;
  begin
    //gsbN
    Nd := Node;
    while Nd <> nil do
    begin
      AddKeyHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        //qȂċA
        RoopKeyScan(Nd.getFirstChild,ls);
      end;
      Nd := Nd.GetNextSibling;
    end;
  end;
var
  ls: TStringList;
  Nd: TTreeNode;
begin
  ls := TStringList.Create;
  try
    ls.Add('<html>');
    ls.Add('<head>');
      ls.Add('<title>' + FProjectTitle + '</title>');
    ls.Add('</head>');
    ls.Add('<body>');
      ls.Add('<UL>');
        //gsbN
        Nd := ContentTree.Items.GetFirstNode;
        while Nd <> nil do
        begin
          AddKeyHTML(Nd,ls);

          if Nd.HasChildren then
          begin
            //qȂċA
            RoopKeyScan(Nd.getFirstChild,ls);
          end;
          Nd := Nd.getNextSibling;
        end;
      ls.Add('</UL>');
    ls.Add('</body>');
    ls.Add('</html>');
    ls.SaveToFile(FileName);
  finally
    ls.Free;
  end;
end;

function CreateTempName(Dir: String; Ext: String = '.html'): String;
var
  Buf: array[0..4096] of Char;
begin
  GetTempFileName(PChar(Dir),'tmp',0,Buf);
  DeleteFile(Buf);
  lstrcpy(Buf,Pchar(ChangeFileExt(Buf,Ext)));
  Result := Buf;
end;

procedure TFormMain.ExportHsXProject(const ExpDir: String);
begin
  ExportHsXHxC(ExpDir + '\' + FProjectPathName + '.HxC');
  ExportHsXToc(ExpDir + '\' + FProjectPathName + '.HxT');
  ExportHsXKey(ExpDir + '\' + FProjectPathName + '.HxK');
  ExportHsXMap(ExpDir + '\' + FProjectPathName + '.HxF');
  ExportHTM(ExpDir);
end;

procedure TFormMain.ExportHsXHxC(const FileName: String);
var
  List: TStringList;
  Fn: String;
begin
  List := TStringList.Create;
  try
    Fn := ExtractFileName(FileName);
    List.Add('<?xml version="1.0" encoding="shift_jis"?>');
    List.Add('<!DOCTYPE HelpCollection SYSTEM "MS-Help://Hx/Resources/HelpCollection.DTD">');
    List.Add('<HelpCollection DTDVersion = "1.0"');
    List.Add(#9#9+'LangId = "1041"');
    List.Add(#9#9+'Title = "' + FProjectTitle + '"');
    List.Add(#9#9+'Font = "MS UI Gothic,10,128">');
    List.Add(#9+'<CompilerOptions OutputFile = "' +
      ChangeFileExt(Fn,'.HxS') + '"');
    List.Add(#9#9+'CreateFullTextIndex = "Yes"');
    List.Add(#9#9+'CompileResult = "Hxs">');
    List.Add(#9+'<IncludeFile File = "' +
      ChangeFileExt(Fn,'.HxF') + '"/>');
    List.Add(#9+'</CompilerOptions>');
    List.Add(#9+'<TOCDef File = "' + ChangeFileExt(Fn,'.HxT') + '"/>');
    List.Add(#9+'<KeywordIndexDef File = "' +
      ChangeFileExt(Fn,'.HxK') + '"/>');
    List.Add(#9+'<KeywordIndexDef File = "NamedURLIndex.HxK"/>');
    List.Add(#9+'<ItemMoniker Name = "!DefaultTOC"');
    List.Add(#9#9+'ProgId = "HxDs.HxHierarchy"');
    List.Add(#9#9+'InitData = "' + FProjectTitle + '"/>');
    List.Add(#9+'<ItemMoniker Name = "!DefaultFullTextSearch"');
    List.Add(#9#9+'ProgId = "HxDs.HxFullTextSearch"');
    List.Add(#9#9+'InitData = "AnyString"/>');
    List.Add(#9+'<ItemMoniker Name = "!DefaultKeywordIndex"');
    List.Add(#9#9+'ProgId = "HxDs.HxIndex"');
    List.Add(#9#9+'InitData = "K"/>');
    List.Add(#9+'<ItemMoniker Name = "!NamedURLIndex_index"');
    List.Add(#9#9+'ProgId = "HxDs.HxIndex"');
    List.Add(#9#9+'InitData = "NamedURLIndex"/>');
    List.Add(#9+'<ItemMoniker Name = "!DefaultContextWindowIndex"');
    List.Add(#9#9+'ProgId = "HxDs.HxIndex"');
    List.Add(#9#9+'InitData = "F"/>');
    List.Add(#9+'<ItemMoniker Name = "!DefaultNamedUrlIndex"');
    List.Add(#9#9+'ProgId = "HxDs.HxIndex"');
    List.Add(#9#9+'InitData = "NamedUrlIndex"/>');
    List.Add('</HelpCollection>');
    List.SaveToFile(FileName);
  finally
    List.Free;
  end;
end;

procedure TFormMain.ExportHsXToc(const FileName: String);
  procedure AddTopicHTML(Node: TTreeNode; ls: TStringList);
  var
    t: TTopicItem;
  begin
    t := TTopicItem(Node.Data);
    case t.TopicType of
    TTPBook:
      begin
        if t.FBookEdit then
        begin
          ls.Add('<HelpTOCNode Title = "' + t.Name + '" Url = "' +
            ChangeFileExt(t.Path,'.htm') + '">');
        end else
        begin
          ls.Add('<HelpTOCNode Title = "' + t.Name + '">');
        end;
      end;
    TTPItem:
      begin
        ls.Add('<HelpTOCNode Title = "' + t.Name + '" Url = "' +
          ChangeFileExt(t.Path,'.htm') + '" />');
      end;
    end;
  end;
  procedure RoopTopicScan(Node: TTreeNode; ls: TStringList);
  var
    Nd: TTreeNode;
  begin
    //gsbN
    Nd := Node;
    while Nd <> nil do
    begin
      AddTopicHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        RoopTopicScan(Nd.getFirstChild,ls);
      end;

      if TTopicItem(Nd.Data).TopicType = TTPBook then
      begin
        ls.Add('</HelpTOCNode>');
      end;

      Nd := Nd.GetNextSibling;
    end;
  end;
var
  ls: TStringList;
  Nd: TTreeNode;
begin
  ls := TStringList.Create;
  try
    ls.Add('<?xml version="1.0" encoding="shift_jis"?>');
    ls.Add('<!DOCTYPE HelpTOC SYSTEM "MS-Help://Hx/Resources/HelpTOC.DTD">');
    ls.Add('<HelpTOC DTDVersion = "1.0" LangId = "1041">');
    //gsbN
    Nd := ContentTree.Items.GetFirstNode;
    while Nd <> nil do
    begin
      AddTopicHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        //qȂċA
        RoopTopicScan(Nd.getFirstChild,ls);
      end;

      if TTopicItem(Nd.Data).TopicType = TTPBook then
      begin
        ls.Add('</HelpTOCNode>');
      end;

      Nd := Nd.getNextSibling;
    end;
    ls.Add('</HelpTOC>');
    ls.SaveToFile(FileName);
  finally
    ls.Free;
  end;
end;

procedure TFormMain.ExportHsXKey(const FileName: String);
  procedure AddKeyHTML(Node: TTreeNode; ls: TStringList;
    namekey: boolean = False);
  var
    t: TTopicItem;
    ND: TTreeNode;
  begin
    t := TTopicItem(Node.Data);
    case t.TopicType of
    TTPBook:
      begin
        //̍ڂ̎qĒǉ
        Nd := Node.getFirstChild;
        if Nd <> nil then
        begin
          ls.Add('<Keyword Term = "' + TTopicItem(Node.Data).Key + '">');
        end;
        while Nd <> nil do
        begin
          ls.Add('<Jump Url = "' +
            ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') +
            '" />');
          Nd := Nd.getNextSibling;
        end;
        ls.Add('</Keyword>');
      end;
    TTPItem:
      begin
        ls.Add('<Keyword Term = "' + t.Key + '">');
        ls.Add('<Jump Url = "' +
          ChangeFileExt(t.Path,'.htm') +
          '" />');
        ls.Add('</Keyword>');
      end;
    end;
  end;
  procedure RoopKeyScan(Node: TTreeNode; ls: TStringList;
    namekey: boolean = False);
  var
    Nd: TTreeNode;
  begin
    //gsbN
    Nd := Node;
    while Nd <> nil do
    begin
      AddKeyHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        //qȂċA
        RoopKeyScan(Nd.getFirstChild,ls,namekey);
      end;
      Nd := Nd.GetNextSibling;
    end;
  end;
var
  ls: TStringList;
  Nd: TTreeNode;
  Val: String;
begin
  ls := TStringList.Create;
  try
    ls.Add('<?xml version="1.0" encoding="shift_jis"?>');
    ls.Add('<!DOCTYPE HelpIndex SYSTEM "MS-Help://Hx/Resources/HelpIndex.DTD">');
    ls.Add('<HelpIndex Name = "K" DTDVersion = "1.0" Visible = "Yes"');
    ls.Add(#9+'LangId = "1041">');
        //gsbN
        Nd := ContentTree.Items.GetFirstNode;
        while Nd <> nil do
        begin
          AddKeyHTML(Nd,ls);

          if Nd.HasChildren then
          begin
            //qȂċA
            RoopKeyScan(Nd.getFirstChild,ls);
          end;
          Nd := Nd.getNextSibling;
        end;
    ls.Add('</HelpIndex>');
    ls.SaveToFile(FileName);

    //NamedURLIndex.HxKo
    ls.Text := '<?xml version="1.0" encoding="shift_jis"?>';
    ls.Add('<!DOCTYPE HelpIndex SYSTEM "MS-Help://Hx/Resources/HelpIndex.DTD">');
    ls.Add('<HelpIndex Name = "NamedUrlIndex" DTDVersion = "1.0" Visible = "No">');
    ls.Add(#9+'<Keyword Term = "DefaultPage">');
    Val := FProjectTopPage;
    if Val <> '' then
    begin
      Val := ChangeFileExt(Val,'.htm');
      ls.Add(#9+'<Jump Url = "' + Val + '" />');
    end;
    ls.Add('</Keyword>');
      //gsbN
      Nd := ContentTree.Items.GetFirstNode;
      while Nd <> nil do
      begin
        AddKeyHTML(Nd,ls);

        if Nd.HasChildren then
        begin
          //qȂċA
          RoopKeyScan(Nd.getFirstChild,ls);
        end;
        Nd := Nd.getNextSibling;
      end;
    ls.Add('</HelpIndex>');
    ls.SaveToFile(ExtractFilePath(FileName) + 'NamedURLIndex.HxK');
  finally
    ls.Free;
  end;
end;

procedure TFormMain.ExportHsXMap(const FileName: String);
  procedure scandir(const dir,topdir: String; FilesList: TStrings);
  var
    FSN: String;
    sr: TSearchRec;
    ext: string;
  begin
    if FindFirst(dir + '\*.*', faAnyFile, sr) = 0 then
    begin
      repeat
        if (sr.Name = '.') or (sr.Name = '..') then
          Continue;
        if (sr.Attr and faDirectory) <> 0 then
        begin
          scandir(dir + '\' + sr.Name,topdir,FilesList);
        end else
        begin
          ext := AnsiLowerCase(ExtractFileExt(sr.Name));
          if (ext = '.htm') or (ext = '.html') or (ext = '.jpg')
           or (ext = '.gif') or (ext = '.png') or (ext = '.jpeg')
           or (ext = '.bmp') or (ext = '.ico') or (ext = '.js')
           or (ext = '.css') or (ext = '.txt') then
          begin
            FSN := ExtractRelativePath(
              topdir+'\',dir + '\' + sr.Name);
            if FilesList.IndexOf('<File Url = "' + FSN + '" />') = -1 then
              FilesList.Add('<File Url = "' + FSN + '" />');
          end;
        end;
      until FindNext(sr) <> 0;
        FindClose(sr);
    end;
  end;
var
  FilesList: TStringList;
  Nd: TTreeNode;
  FSN: String;
  sr: TSearchRec;
  ext: string;
begin
  FilesList := TStringList.Create;
  try
    FilesList.Add('<?xml version="1.0" encoding="shift_jis"?>');
    FilesList.Add('<!DOCTYPE HelpFileList SYSTEM "MS-Help://Hx/Resources/HelpFileList.DTD">');
    FilesList.Add('<HelpFileList DTDVersion = "1.0">');
    Nd := ContentTree.Items.GetFirstNode;
    while Nd <> nil do
    begin
      if TTopicItem(Nd.Data).TopicType = TTPItem then
      begin
        FSN := ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm');
        if FilesList.IndexOf('<File Url = "' + FSN + '" />') = -1 then
          FilesList.Add('<File Url = "' + FSN + '" />');
      end;
      Nd := Nd.GetNext;
    end;
    //OőSo^ȂƂȂ悤Ȃ̂
    if FindFirst(ExtractFilePath(FileName) + '*.*', faAnyFile, sr) = 0 then
    begin
      repeat
        if (sr.Name = '.') or (sr.Name = '..') then
          Continue;
        if (sr.Attr and faDirectory) <> 0 then
        begin
          scandir(ExtractFileDir(FileName),ExtractFileDir(FileName),
            FilesList);
        end else
        begin
          ext := AnsiLowerCase(ExtractFileExt(sr.Name));
          if (ext = '.htm') or (ext = '.html') or (ext = '.jpg')
           or (ext = '.gif') or (ext = '.png') or (ext = '.jpeg')
           or (ext = '.bmp') or (ext = '.ico') or (ext = '.js')
           or (ext = '.css') or (ext = '.txt') then
          begin
            FSN := ExtractRelativePath(ExtractFilePath(FileName),
              ExtractFilePath(FileName) + sr.Name);
            if FilesList.IndexOf('<File Url = "' + FSN + '" />') = -1 then
              FilesList.Add('<File Url = "' + FSN + '" />');
          end;
        end;
      until FindNext(sr) <> 0;
        FindClose(sr);
    end;
    FilesList.Add('</HelpFileList>');
    FilesList.SaveToFile(FileName);
  finally
    FilesList.Free;
  end;
end;

procedure TFormMain.ExportCHMProject(const ExpDir: String);
begin
  //Ƃ肠Aڎt@Cfo
  ExportHHC(ExpDir + '\' + FProjectPathName + '.hhc');
  ExportHHK(ExpDir + '\' + FProjectPathName + '.hhk');
  ExportHHP(ExpDir + '\' + FProjectPathName + '.hhp');
  ExportHTM(ExpDir);
end;

procedure TFormMain.ExportJavaHelpProject(const ExpDir: String);
begin
  ExportJHelpSet(ExpDir + '\' + FProjectPathName + 'JHS.hs');
  ExportJMap(ExpDir + '\' + FProjectPathName + 'JMap.jhm');
  ExportJToc(ExpDir + '\' + FProjectPathName + 'JToc.xml');
  ExportJHelpIndex(ExpDir + '\' + FProjectPathName + 'JIndex.xml');
  ExportHTM(ExpDir);
end;

procedure TFormMain.ExportJHelpSet(const FileName: String);
var
  List: TStringList;
begin
  List := TStringList.Create;
  try
    List.Add('<?xml version=''1.0'' encoding=''Shift-JIS'' ?>');
    List.Add('<!DOCTYPE helpset');
    List.Add('  PUBLIC "-//Sun Microsystems Inc.//DTD JavaHelp HelpSet Version 2.0//EN"');
    List.Add('         "http://java.sun.com/products/javahelp/helpset_2_0.dtd">');
    List.Add('<helpset version="1.0">');
    List.Add('  <title>' + FProjectTitle + '</title>');
    List.Add('  <maps>');
    List.Add('    <homeID>top</homeID>');
    List.Add('    <mapref location="' + FProjectPathName + 'JMap.jhm' + '"/>');
    List.Add('  </maps>');
    List.Add('  <view>');
    List.Add('    <name>TOC</name>');
    List.Add('    <label>ڎ</label>');
    List.Add('    <type>javax.help.TOCView</type>');
    List.Add('    <data>' + FProjectPathName + 'JToc.xml' + '</data>');
    List.Add('  </view>');
    List.Add('  <view>');
    List.Add('    <name>TOC</name>');
    List.Add('    <label></label>');
    List.Add('    <type>javax.help.IndexView</type>');
    List.Add('    <data>' + FProjectPathName + 'JIndex.xml' + '</data>');
    List.Add('  </view>');    {
    List.Add('  <view>');
    List.Add('    <name>Search</name>');
    List.Add('    <label></label>');
    List.Add('    <type>javax.help.SearchView</type>');
    List.Add('    <data engine="com.sun.java.help.search.DefaultSearchEngine">');
    List.Add('      JavaHelpSearch');
    List.Add('    </data>');
    List.Add('  </view>');    }
    List.Add('  <view>');
    List.Add('    <name>FAV</name>');
    List.Add('    <label>Cɓ</label>');
    List.Add('    <type>javax.help.FavoritesView</type>');
    List.Add('  </view>');
    List.Add('</helpset>');
    List.SaveToFile(FileName);
  finally
    List.Free;
  end;
end;

procedure TFormMain.ExportJToc(const FileName: String);
  procedure AddKeyHTML(Node: TTreeNode; ls: TStringList);
  var
    t: TTopicItem;
  begin
    t := TTopicItem(Node.Data);
    case t.TopicType of
    TTPBook:
      begin
        if t.FBookEdit then
        begin
          ls.Add('<tocitem text="' + t.Key + '" target="' + t.ID + '">');
        end else
        begin
          ls.Add('<tocitem text="' + t.Key + '">');
        end;

      end;
    TTPItem:
      begin
        ls.Add('  <tocitem text="' + t.Key + '" target="' + t.ID + '"/>');
      end;
    end;
  end;
  procedure RoopKeyScan(Node: TTreeNode; ls: TStringList);
  var
    Nd: TTreeNode;
  begin
    //gsbN
    Nd := Node;
    while Nd <> nil do
    begin
      AddKeyHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        //qȂċA
        RoopKeyScan(Nd.getFirstChild,ls);
        ls.Add('</tocitem>');
      end;
      Nd := Nd.GetNextSibling;
    end;
  end;
var
  ls: TStringList;
  Nd: TTreeNode;
begin
  ls := TStringList.Create;
  try
    ls.Add('<?xml version=''1.0'' encoding=''Shift-JIS'' ?>');
    ls.Add('<!DOCTYPE toc');
    ls.Add('  PUBLIC "-//Sun Microsystems Inc.//DTD JavaHelp TOC Version 1.0//EN"');
    ls.Add('         "http://java.sun.com/products/javahelp/toc_1_0.dtd">');
    ls.Add('<map version="1.0">');
    ls.Add('<toc xml:lang="ja">');
        //gsbN
        Nd := ContentTree.Items.GetFirstNode;
        while Nd <> nil do
        begin
          AddKeyHTML(Nd,ls);

          if Nd.HasChildren then
          begin
            //qȂċA
            RoopKeyScan(Nd.getFirstChild,ls);
            ls.Add('</tocitem>');
          end;
          Nd := Nd.getNextSibling;
        end;
    ls.Add('</toc>');
    ls.SaveToFile(FileName);
  finally
    ls.Free;
  end;
end;

procedure TFormMain.ExportJMap(const FileName: String);
var
  List: TStringList;
  Val: String;
  Nd: TTreeNode;
begin
  List := TStringList.Create;
  try
    List.Add('<?xml version=''1.0'' encoding=''Shift-JIS'' ?>');
    List.Add('<!DOCTYPE map');
    List.Add('  PUBLIC "-//Sun Microsystems Inc.//DTD JavaHelp Map Version 1.0//EN""');
    List.Add('         "http://java.sun.com/products/javahelp/map_1_0.dtd">');
    List.Add('<map version="1.0">');
    List.Add('	<mapID target="toplevelfolder" url="images/toplevel.gif" />');
    Val := FProjectTopPage;
    if Val <> '' then
    begin
      Val := ChangeFileExt(Val,'.htm');
      List.Add('Default topic=' + Val);
      List.Add('	<mapID target="top" url="' + Val + '" />');
    end;

    Nd := ContentTree.Items.GetFirstNode;
    while Nd <> nil do
    begin
      List.Add('	<mapID target="' + TTopicItem(Nd.Data).ID +
        '" url="' + ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') + '" />');
      Nd := Nd.GetNext;
    end;
    List.Add('</map>');
    List.SaveToFile(FileName);
  finally
    List.Free;
  end;
end;

procedure TFormMain.ExportJHelpIndex(const FileName: String);
  procedure AddKeyHTML(Node: TTreeNode; ls: TStringList);
  var
    t: TTopicItem;
    ND: TTreeNode;
  begin
    t := TTopicItem(Node.Data);
    case t.TopicType of
    TTPBook:
      begin
        //̍ڂ̎qĒǉ
        Nd := Node.getFirstChild;
        if Nd <> nil then
        begin
          ls.Add('<indexitem text="' + TTopicItem(Node.Data).Key +
            '" expand="false">');
        end;
        while Nd <> nil do
        begin
          ls.Add('  <indexitem text="' + TTopicItem(Nd.Data).Key +
            '" target="' + TTopicItem(Nd.Data).ID + '"/>');
          Nd := Nd.getNextSibling;
        end;
        ls.Add('</indexitem>');
      end;
    TTPItem:
      begin
        ls.Add('  <indexitem text="' + t.Key + '" target="' + t.ID + '"/>');
      end;
    end;
  end;
  procedure RoopKeyScan(Node: TTreeNode; ls: TStringList);
  var
    Nd: TTreeNode;
  begin
    //gsbN
    Nd := Node;
    while Nd <> nil do
    begin
      AddKeyHTML(Nd,ls);

      if Nd.HasChildren then
      begin
        //qȂċA
        RoopKeyScan(Nd.getFirstChild,ls);
      end;
      Nd := Nd.GetNextSibling;
    end;
  end;
var
  ls: TStringList;
  Nd: TTreeNode;
begin
  ls := TStringList.Create;
  try
    ls.Add('<?xml version=''1.0'' encoding=''Shift-JIS'' ?>');
    ls.Add('<!DOCTYPE index');
    ls.Add('  PUBLIC "-//Sun Microsystems Inc.//DTD JavaHelp Index Version 1.0//EN"');
    ls.Add('         "http://java.sun.com/products/javahelp/index_1_0.dtd">');
    ls.Add('<index version="1.0">');
        //gsbN
        Nd := ContentTree.Items.GetFirstNode;
        while Nd <> nil do
        begin
          AddKeyHTML(Nd,ls);

          if Nd.HasChildren then
          begin
            //qȂċA
            RoopKeyScan(Nd.getFirstChild,ls);
          end;
          Nd := Nd.getNextSibling;
        end;
    ls.Add('</index>');
    ls.SaveToFile(FileName);
  finally
    ls.Free;
  end;
end;

function TFormMain.GetTempDirName(Ext: String): String;
var
  Path,Buf: array[0..4096] of Char;
begin
  GetTempPath(4096,Path);
  GetTempFileName(Path,'tmp',0,Buf);
  DeleteFile(Buf);
  lstrcpy(Buf,Pchar(ChangeFileExt(Buf,Ext)));
  Result := Buf;
end;

function TFormMain.ControlCapt(BMP: TBitMap): Boolean;
var
  F: TControlCaptForm;
  DC: HDC;
  Rect: TRect;
begin
  Result := False;
  F := TControlCaptForm.Create(self);
  if F.ShowModal = mrok then
  begin
    F.Hide;
    Sleep(100);
    if F.FPrevHWnd <> 0 then
    begin
      GetWindowRect(F.FPrevHWnd,Rect);
      BMP.Width := Rect.Right - Rect.Left;
      BMP.Height := Rect.Bottom - Rect.Top;

      DC := GetWindowDC(F.FPrevHWnd);
      try
        bitblt(BMP.Canvas.Handle,0,0,
          BMP.Width,BMP.Height,dc,0,0,srccopy);
      finally
        Releasedc(0,dc);
      end;
      Result := True;
    end;
  end;
end;

procedure TFormMain.ActWndCapt(BMP: TBitMap);
var
  DC: HDC;
  Rect: TRect;
  Act: HWND;
begin
  //BMP͍Ă̂O
  Act := GetForegroundWindow;
  if Act <> 0 then
  begin
    GetWindowRect(Act,Rect);
    BMP.Width := Rect.Right - Rect.Left;
    BMP.Height := Rect.Bottom - Rect.Top;

    DC := GetWindowDC(Act);
    try
      bitblt(BMP.Canvas.Handle,0,0,BMP.Width,BMP.Height,dc,0,0,srccopy);
    finally
      Releasedc(0,dc);
    end;
  end;
end;

function TFormMain.BoxWndCapt(BMP,BM2: TBitMap): Boolean;
var
  ALBMP: TBitMap;
  FR: TRect;
  F: TSetCaptureForm;
begin
  Result := False;
  ALBMP := TBitMap.Create;
  F := TSetCaptureForm.Create(self);
  try
    AllWndCapt(ALBMP);
    F.CaptureImage.Picture.Assign(ALBMP);
    F.CaptureImage.Width := ALBMP.Width;
    F.CaptureImage.Height := ALBMP.Height;
    if F.ShowModal = mrok then
    begin
      BM2.Width := Abs(F.FPrevPoint.X - F.FClickPoint.X);
      BM2.Height := Abs(F.FPrevPoint.Y - F.FClickPoint.Y);
      if F.FPrevPoint.X > F.FClickPoint.X then
      begin
        FR.Left := F.FClickPoint.X;
        FR.Right := F.FPrevPoint.X;
      end else
      begin
        FR.Left := F.FPrevPoint.X;
        FR.Right := F.FClickPoint.X;
      end;

      if F.FPrevPoint.Y > F.FClickPoint.Y then
      begin
        FR.Top := F.FClickPoint.Y;
        FR.Bottom := F.FPrevPoint.Y;
      end else
      begin
        FR.Top := F.FPrevPoint.Y;
        FR.Bottom := F.FClickPoint.Y;
      end;
      BM2.Canvas.CopyRect(Rect(0,0,BM2.Width,BM2.Height),ALBMP.Canvas,
        FR);
      Result := True;
    end;
  finally
    ALBMP.Free;
  end;
end;

procedure TFormMain.AllWndCapt(BMP: TBitMap);
var
  DC: HDC;
begin
  //BMP͍Ă̂O
  BMP.Width := Screen.Width;
  BMP.Height := Screen.Height;

  DC := GetDC(0);
  try
    bitblt(BMP.Canvas.Handle,0,0,BMP.Width,BMP.Height,dc,0,0,srccopy);
  finally
    Releasedc(0,dc);
  end;
end;

procedure TFormMain.MainWndForg;
begin
  Application.Restore;
  ShowWindow(Self.Handle,SW_SHOW);
  SetForegroundWindow(self.Handle);
  SetWindowPos(Handle,HWND_TOP,0,0,0,0,SWP_SHOWWINDOW
    or SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TFormMain.WMHotKey(var Msg: TWMHotKey);
begin
  case Msg.HotKey of
  KeyID_AllCapt:
    begin
      AllCaptureClick(nil);
    end;
  KeyID_WndCapt:
    begin
      WndCaptureClick(nil);
    end;
  KeyID_BoxCapt:
    begin
      BoxCaptureClick(nil);
    end;
  KeyID_ControlCapt:
    begin
      ControlCaptureClick(nil);
    end;
  end;
end;


procedure TFormMain.WMUSER(var Msg: TMsg);
var
  Pos: TPoint;
begin
  case Msg.wParam of
  WM_RBUTTONDOWN:
    begin
      SetForegroundWindow(Handle);
      GetCursorPos(Pos);
      CapturePopup.Popup(Pos.X,Pos.Y);
      PostMessage(Handle, WM_NULL, 0, 0);
    end;
  WM_LBUTTONDOWN:
    begin
      SetForegroundWindow(Handle);
      GetCursorPos(Pos);
      CapturePopup.Popup(Pos.X,Pos.Y);
      PostMessage(Handle, WM_NULL, 0, 0);
    end;
  end;
end;

//*****************************************************************************/
//*                      c[ɉ摜Zbg
//*****************************************************************************/
procedure TFormMain.SetImage(Node: TTreeNode);
begin
  case TTopicItem(Node.Data).TopicType of
  TTPBook,TTPItem:
    begin
      Node.SelectedIndex := TTopicItem(Node.Data).FImageIndex;
      Node.ImageIndex := TTopicItem(Node.Data).FImageIndex;
    end;
  TTPMarge:
    begin
      Node.SelectedIndex := 4;
      Node.ImageIndex := 4;
    end;
  end;
end;

//*****************************************************************************/
//*                      qm[hۂɒǉi}[W͕)
//*****************************************************************************/
procedure TFormMain.AddNodeTopic(Types: TTopicType;
  const Name,Key,Context,NumId: String;
  child: Boolean; ImageIndex: Integer);
var
  Item: TTopicItem;
  List: TStringList;
  Path: String;
begin
  FOnEditFlag := True;
  inc(FProjectContextIDInc);
  List := TStringList.Create;
  try
    List.Add('[Info]');
    List.Add('Name=' + Name);
    List.Add('KeyWord=' + Key);
    List.Add('Context=' + Context);
    List.Add('[Date]');
    if FProjectGenNameTitle then
      Path := Name + '.db' else
      Path := GenMagicNumber + '.db';
    List.SaveToFile(ExtractFilePath(FProjectFullPath) +Path);
  finally
    List.Free;
  end;
  Item := TTopicItem.Create;
  Item.TopicType := Types;
  Item.Name := Name;
  Item.Key := Key;
  Item.ID := Context;
  Item.IDNum := NumId;
  Item.Path := Path;
  Item.FImageIndex := ImageIndex;
  Item.Date := '';
  if Child then
  begin
    if ContentTree.Selected = nil then
    begin
      SetImage(ContentTree.Items.AddObject(nil,Item.Name,Item));
    end else
    begin
      if TTopicItem(ContentTree.Selected.Data).TopicType = TTPBook then
      begin
        SetImage(ContentTree.Items.AddChildObject(ContentTree.Selected,
          Item.Name,Item));
      end else
      begin
        SetImage(ContentTree.Items.AddObject(ContentTree.Selected,
          Item.Name,Item));
      end;
    end;
  end else
  begin
    if ContentTree.Selected = nil then
    begin
      SetImage(ContentTree.Items.AddObject(nil,Item.Name,Item));
    end else
    begin
      SetImage(ContentTree.Items.AddObject(ContentTree.Selected,
        Item.Name,Item));
    end;
  end;
end;

//*****************************************************************************/
//*                      ConvartConst̃R}hϊB
//*                      ߂l͎̃XLJnʒu
//*****************************************************************************/
function TFormMain.ConvCMD(const Command: String;
  var Edit: String; StartPos, EndPos: Integer; Node: TTopicItem;
      TreeNode: TTreeNode): Integer;
  function RecvItem(Node: TTreeNode; Next: Boolean): TTreeNode;
  begin
    Result := nil;
    while Node <> nil do
    begin
      if TTopicItem(Node.Data).TopicType <> TTPBook then
      begin
        Result := Node;
        Exit;
      end;
      if Next then
        Node := Node.GetNext else
        Node := Node.GetPrev;
    end;
  end;
var
  Key, Temp: String;
  Nd: TTreeNode;
begin
  //X^[gʒuI܂łƂ肠
  Delete(Edit,StartPos,EndPos-StartPos);
  //XV
  if Command = 'HelpUpdateTime' then
  begin
    Key := FormatDateTime(LongDateFormat,Now);
  end;
  //쌠
  if Command = 'HelpCopyRight' then
  begin
    Key := FProjectCopyRight;
  end;
  //vWFNg̖O
  if Command = 'ProjectName' then
  begin
    Key := FProjectTitle;
  end;
  //z[y[W
  if Command = 'WebPage' then
  begin
    Key := FProjectWeb;
  end;
  //z[y[Wւ̃N
  if Command = 'WebPageLink' then
  begin
    Key := '<a href="' + FProjectWeb + '">';
  end;
  if Node <> nil then
  begin
    if Command = 'TipTitle' then
    begin
      Key := Node.Name;
    end;
  end;
  if TreeNode <> nil then
  begin
    //߂邻̂P
    if Command = 'Back' then
    begin
      Nd := RecvItem(TreeNode.GetPrev,False);
      if Nd <> nil then
        Key := '<a href="' +
          ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') + '">';
    end;
    //ւ̂P
    if Command = 'Next' then
    begin
      Nd := RecvItem(TreeNode.GetNext,True);
      if Nd <> nil then
        Key := '<a href="' +
          ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') + '">';
    end;
    //߂in摜
    if Command = 'Back2' then
    begin
      Nd := RecvItem(TreeNode.GetPrev,False);

      if Nd <> nil then
      begin
        Key := '<a href="' +
          ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') + '">' +
          '<img alt="O" src="' + FProjectTheme +  '/back.gif"></a>';
      end else
      begin
        Key := '';
      end;
    end;
    //in摜
    if Command = 'Next2' then
    begin
      Nd := RecvItem(TreeNode.GetNext,True);
      if Nd <> nil then
      begin
        Key := '<a href="' +
          ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') + '">' +
          '<img alt="" src="' + FProjectTheme +  '/next.gif"></a>';
      end else
      begin
        Key := '';
      end;
    end;
    //irQ[g
    if Command = 'Navi' then
    begin
      if TreeNode <> nil then
      begin
        Nd := TreeNode.Parent;
        while Nd <> nil do
        begin
          Temp := '<a href="' +
            ChangeFileExt(TTopicItem(Nd.Data).Path,'.htm') + '">' +
            Temp + TTopicItem(Nd.Data).Name + '</a> > ';
          Nd := Nd.Parent;
        end;

        Temp := Temp + TTopicItem(TreeNode.Data).Name;
        Key := Temp;
      end;
    end;
  end;
  Insert(Key,Edit,StartPos);
  Result := StartPos + Length(Key);
end;

//*****************************************************************************/
//*                      萔lϊ̂Ԃ
//*****************************************************************************/
function TFormMain.ConvartConst(const Str: String;
  Node: TTopicItem; TreeNode: TTreeNode): String;
var
  i,x,ln,cp: Integer;
  Comand: String;
begin
  Result := Str;
  if Result = '' then
    Exit;
  i := 0;
  while Length(Result) >= i do
  begin
    //͂߂ɃCNg
    inc(i);
    //ϊĂ
    if (Result[i] = '<') then
    begin
      ln := Length(Result);
      if (Copy(Result,i+1,Length('!--%')) <> '!--%') then
      begin
        inc(i);
        Continue;
      end;
      //R}h𔲂oĂ݂
      cp := i + Length('!--%');
      for x := cp to ln do
      begin
        if Copy(Result,x,Length('%-->')) = '%-->' then
        begin
          //Rs[
          Comand := Copy(Result,cp+1,x-cp-1);
          //R}h
          i := ConvCMD(Comand,Result,i,x + Length('%-->'),Node,TreeNode);
          Break;
        end;
      end;
    end;
  end;
end;

//*****************************************************************************/
//*                        c[̊J
//*****************************************************************************/
procedure TFormMain.FreeTempList;
var
  i: integer;
begin
  for i := FDeleteTempList.Count-1 downto 0 do
  begin
    if DeleteFile(FDeleteTempList[i]) then
      FdeleteTempList.Delete(i);
  end;
end;

//*****************************************************************************/
//*                      e|t@C
//*****************************************************************************/
function TFormMain.CreateTempName(Dir: String; Ext: String = ''): String;
var
  Buf: array[0..4096] of Char;
begin
  GetTempFileName(PChar(Dir),'tmp',0,Buf);
  DeleteFile(Buf);
  lstrcpy(Buf,Pchar(ChangeFileExt(Buf,Ext)));
  Result := Buf;
end;

//*****************************************************************************/
//*                      Body^OHTML𓾂
//*****************************************************************************/
function TFormMain.GetBodyHTML: String;
var
  Ele: IHTMLDocument2;
begin
  if EditBrowser.Document = nil then
    Exit;
  Ele := (EditBrowser.Document as IHTMLDocument2);
  Result := Ele.body.innerHTML;
end;

//*****************************************************************************/
//*                      gsbN쐬̃t@C
//*****************************************************************************/
function TFormMain.GenMagicNumber: String;
begin
  Result := FormatDateTime('yyyymdhnsz',Now);
end;

//*****************************************************************************/
//*                      Recc[̓ǂݏo
//*****************************************************************************/
procedure TFormMain.LoadFromContents(const FileName: String);
  function SameString(const AText,BText: PChar): Boolean;
  begin
    Result := False;
    if AnsiStrIComp(AText,BText) = 0 then
      Result := True;
  end;
  function NumberScan(const Scan: String): Integer;
  var
    point: Integer;
  begin
    Result := -1;
    point := AnsiPos(':',Scan);
    if point <> 0 then
    begin
      Result := StrToInt( Copy(Scan,1,point-1) );
    end;
  end;
  function GetNoValText(const Scan: String): String;
  var
    point: Integer;
  begin
    Result := '';
    point := AnsiPos(':',Scan);
    if point <> 0 then
    begin
      Result := Copy(Scan,point+1,length(Scan)-point);
    end;
  end;

var
  List: TStringList;
  ReadMode: Boolean;
  Buf: String;
  Item: TTopicItem;
  i,x,Level,BefLevel: integer;
  befitem,Parent:TTreeNode;
begin
  AllFreeTree;
  ReadMode := False;
  Item := nil;
  Level := 0;
  BefLevel := 0;
  BefItem := nil;
  if FileExists(FileName) then
  begin
    List := TStringList.Create;
    ContentTree.Items.BeginUpdate;
    try
      List.LoadFromFile(FileName);
      for i := 0 to List.Count-1 do
      begin
        Buf := List[i];
        if SameString(Pchar(Buf),'!!!') then
        begin
          ReadMode := True;
          Item := TTopicItem.Create;
          Continue;
        end;
        if SameString(Pchar(Buf),'!!!!') then
        begin
          if ReadMode then
          begin
            if Level > BefLevel then
            begin
              befitem := ContentTree.Items.AddChildObject(befitem,Item.Name,Item);
              SetImage(befitem);
            end else begin
                if Level = BefLevel then
                begin
                  befitem := ContentTree.Items.AddObject(befitem,Item.Name,Item);
                  SetImage(befitem);
                end else begin
                  Parent := befitem;
                  for x := 0 to (befitem.Level - Level) - 1 do
                    Parent := Parent.Parent;
                  befitem := ContentTree.Items.AddObject(Parent,Item.Name,Item);
                  SetImage(befitem);
                end;
            end;
            BefLevel := Level;
            ReadMode := False;
            Continue;
          end;
        end;
        if ReadMode then
        begin
          //ǂ
            case NumberScan(Buf) of
            0:Level := StrToInt(GetNoValText(Buf));
            1:Item.Name := GetNoValText(Buf);
            2:Item.Key := GetNoValText(Buf);
            3:begin
                Item.Path := GetNoValText(Buf);
                //łɃf[^ǂݏoĂ
                Item.Date := ReadDate(ExtractFilePath(FProjectFullPath) +
                  Item.Path);
              end;
            4:Item.ID := GetNoValText(Buf);
            5:begin
                Item.TopicType := TTopicType(StrToIntDef(GetNoValText(Buf),0));
                if Item.TopicType = TTPBook then
                begin
                  Item.FImageIndex := 0;
                end else
                begin
                  Item.FImageIndex := 8;
                end;
              end;
            6:Item.FImageIndex := StrToIntDef(GetNoValText(Buf),0);
            7:Item.IDNum := GetNoValText(Buf);
            8:Item.FBookEdit := StrToBoolDef(GetNoValText(Buf),false);
            end;
          //I
        end;
      end;
    finally
      ContentTree.Items.EndUpdate;
      List.Free;
    end;
  end;
end;

//*****************************************************************************/
//*                      Recc[̊J
//*****************************************************************************/
procedure TFormMain.AllFreeTree;
var
  ND: TTreeNode;
begin
  ContentTree.Items.BeginUpdate;
  try
    ND := ContentTree.Items.GetFirstNode;
    while ND <> nil do
    begin
      TTopicItem(Nd.Data).Free;
      ND := Nd.GetNext;
    end;
    ContentTree.Items.Clear;
  finally
    ContentTree.Items.EndUpdate;
  end;
end;

//*****************************************************************************/
//*                      Recc[̕ۑ
//*****************************************************************************/
procedure TFormMain.SaveToContents(const Path: String);
var
  ND: TTreeNode;
  List,DateList,AddList: TStringList;
  i: Integer;
begin
  if FActiveEditDate <> nil then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
      FActiveEditDate.Date := GetBodyHTML else
      FActiveEditDate.Date := Editor.Text;
  end;

  List := TStringList.Create;
  DateList := TStringList.Create;
  AddList := TStringList.Create;
  try
    ND := ContentTree.Items.GetFirstNode;
    while ND <> nil do
    begin
      //f[^͕ʂɕێ
      List.Add('!!!');
      List.Add('0:' + IntToStr(Nd.Level));
      List.Add('1:' + TTopicItem(Nd.Data).Name);
      List.Add('2:' + TTopicItem(Nd.Data).Key);
      List.Add('3:' + TTopicItem(Nd.Data).Path);
      List.Add('4:' + TTopicItem(Nd.Data).ID);
      List.Add('5:' + IntToStr(Integer(TTopicItem(Nd.Data).TopicType)));
      List.Add('6:' + IntToStr(TTopicItem(Nd.Data).FImageIndex));
      List.Add('7:' + TTopicItem(Nd.Data).IDNum);
      List.Add('8:' + BoolToStr(TTopicItem(Nd.Data).FBookEdit));
      List.Add('!!!!');

      //f[^fo
      DateList.LoadFromFile(ExtractFilePath(Path) + TTopicItem(Nd.Data).Path);
      //[Date]݂܂ŏ܂
      for i := DateList.Count-1 downto 0 do
      begin
        if DateList[i] = '[Date]' then
          Break;
        DateList.Delete(i);
      end;
      //̂Œǉ܂
      AddList.Text := TTopicItem(Nd.Data).Date;
      DateList.AddStrings(AddList);
      DateList.SaveToFile(ExtractFilePath(Path) + TTopicItem(Nd.Data).Path);

      ND := Nd.GetNext;
    end;
    List.SaveToFile(ExtractFilePath(Path) + 'Contents.tdb');
  finally
    AddList.Free;
    DateList.Free;
    List.Free;
  end;

  FOnEditFlag := False;
end;

//*****************************************************************************/
//*                      vWFNg̏o
//*****************************************************************************/
procedure TFormMain.SaveToProject(const Path: String);
var
  ini: TMemIniFile;
begin
  ini := TMemIniFile.Create(Path);
  try
    ini.WriteInteger('Project','ContextUpdate',FProjectContextIDInc);
    ini.WriteString('Project','Title',FProjectTitle);
    ini.WriteString('Project','Copyright',FProjectCopyRight);
    ini.WriteString('Project','Web',FProjectWeb);
    ini.WriteString('Project','deploy',FProjectdeploy);
    ini.WriteString('Project','defaultpage',FProjectTopPage);
    ini.WriteBool('Project','GenNameTitle',FProjectGenNameTitle);
    ini.WriteString('Project','deployname',FProjectDepName);
    ini.WriteInteger('Project','HelpType',FProjectHelpType);
    ini.UpdateFile;
  finally
    ini.Free;
  end;
end;

//*****************************************************************************/
//*                      vWFNg̃[h
//*****************************************************************************/
procedure TFormMain.LoadFormProject(const Path: String);
var
  ini: TMemIniFile;
  idx: Integer;
begin
  if self.FProjectFullPath <> '' then
  begin
    case MessageDlg('݃vWFNgJĂ܂B'+#13#10+
      '̃vWFNgۑ܂H'+#13#10
      ,mtWarning,[mbYes,mbNo,mbCancel],0) of
    mrYes:
      begin
        aacSaveProjectExecute(nil);
      end;
    mrCancel:
      begin
        Exit;
      end;
    end;
  end;

  EditorPanel.Hide;
  EditorTabs.ActiveTabIndex := 0;
  self.FActiveEditDate := nil;
  self.FActiveEditTreeNode := nil;

  idx := FReOpenList.IndexOf(Path);
  if idx <> -1 then
    FReOpenList.Delete(idx);
  FReOpenList.Insert(0,Path);
  CreateDir(ExtractFilePath(Application.ExeName) + 'Settings');
  FReOpenList.SaveToFile(
    ExtractFilePath(Application.ExeName) + 'Settings\ReOpen.db');

  ini := TMemIniFile.Create(Path);
  try
    FProjectFullPath := Path;
    FProjectContextIDInc :=
      ini.ReadInteger('Project','ContextUpdate',FProjectContextIDInc);
    FProjectTheme := ini.ReadString('Project','Theme','Default');
    FProjectWeb := ini.ReadString('Project','Web','');
    FProjectCopyRight := ini.ReadString('Project','Copyright','');
    FProjectTitle := ini.ReadString('Project','Title','');
    FProjectdeploy := ini.ReadString('Project','deploy','');
    FProjectGenNameTitle := ini.ReadBool('Project','GenNameTitle',False);
    FProjectTopPage := ini.ReadString('Project','defaultpage','');
    FProjectPathName := ChangeFileExt(ExtractFileName(FProjectFullPath),'');
    FProjectDepName := ini.ReadString('Project','deployname','');
    FProjectHelpType := ini.ReadInteger('Project','HelpType',HT_HTMLHelp);
    Caption := FProjectTitle;
  finally
    ini.Free;
  end;
  LoadFromContents(ExtractFilePath(Path) + 'Contents.tdb');
end;

procedure TFormMain.aacNewProjectExecute(Sender: TObject);
var
  F: TFormWizard;
begin
  F := TFormWizard.Create(self);
  try
    if F.ShowModal = mrok then
    begin
      LoadFormProject(ExtractFilePath(Application.ExeName) +
        'Project\' + F.LabelProject.Caption + '\' +
        F.LabelProject.Caption + '.sprj');
    end;
  finally
    F.Free;
  end;
end;

procedure TFormMain.aacNewTopicExecute(Sender: TObject);
var
  F: TNewTopicForm;
begin
  F := TNewTopicForm.Create(self);
  try
    F.Caption := 'VKgsbN';
    F.ContextEdit.Text := 'IDH_HELP' + IntToStr(0 + FProjectContextIDInc);
    F.ContextNumEdit.Text := IntToStr(10000 + FProjectContextIDInc);
    F.SpTBXComboBox1.ItemIndex := 8;
    if F.ShowModal = mrok then
    begin
      //gsbN
      AddNodeTopic(TTPItem,F.TopicEdit.Text,F.KeyEdit.Text,
        F.ContextEdit.Text,F.ContextNumEdit.Text,
        F.FChild,F.SpTBXComboBox1.ItemIndex);
    end;
  finally
    F.Free;
  end;
end;

//*****************************************************************************/
//*                      
//*****************************************************************************/
procedure TFormMain.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FDeleteTempList := TStringList.Create;
  FReOpenList := TStringList.Create;
  ReadIni;
  FOnEditFlag := False;

  if FileExists(
    ExtractFilePath(Application.ExeName) + 'Settings\ReOpen.db') then
    FReOpenList.LoadFromFile(
      ExtractFilePath(Application.ExeName) + 'Settings\ReOpen.db');

  po := nil;
  DLLWnd := LoadLibrary('hhctrl.ocx');
  if DLLWnd > 0 then
  begin
    po := GetProcAddress(DLLWnd, 'HtmlHelpA');
    if po <> nil then
      @HtmlHelp := po;
  end;

  if FileExists(
    ExtractFilePath(Application.ExeName) + 'Settings\tbpos.ini') then
    ReadToolBarsPos(ExtractFilePath(Application.ExeName) + 'Settings\tbpos.ini');

  SpHBox.ItemIndex := 0;

  if TTKMouseGestures.Enabled then
  begin
    for i := 0 to ComponentCount - 1 do
    begin
      if TTKMouseGestures.GestureComponents.IndexOf(Components[i].ClassName) = -1 then
        TTKMouseGestures.GestureComponents.Add(Components[i].ClassName);
    end;
    TTKMouseGestures.GestureComponents.Add('MDIClient');
    TTKMouseGestures.GestureComponents.Add('TFormMain');
    TTKMouseGestures.GestureComponents.Add('Internet Explorer_Server');
    TTKMouseGestures.GestureComponents.Add('Shell Embedding');
    TTKMouseGestures.GestureComponents.Add('Edit');
    TTKMouseGestures.GestureComponents.Add('TScrollBox');
    TTKMouseGestures.GestureComponents.Add('TImage');
    TTKMouseGestures.GestureComponents.Add('TSpTBXTabToolbar');
    TTKMouseGestures.GestureComponents.Add('TSpTBXButton.UnicodeClass');
    TTKMouseGestures.GestureComponents.Add('TSpTBXComboBox.UnicodeClass');
    TTKMouseGestures.GestureComponents.Add('TSpTBXEdit.UnicodeClass');
    TTKMouseGestures.GestureComponents.Add('TSpTBXToolbar.UnicodeClass');

    TTKMouseGestures.MouseRightStopComponent.Add('TTreeView');
    TTKMouseGestures.MouseRightStopComponent.Add('TListView');
    TTKMouseGestures.MouseRightStopComponent.Add('TVirtualStringTree');
    TTKMouseGestures.MouseRightStopComponent.Add('TScrollBox');
    TTKMouseGestures.StartHook;
  end;

  if FNoEndCapture then
    aacCaptureExecute(aacCapture);
end;

//*****************************************************************************/
//*                      gsbNACe̕ҏWJn
//*****************************************************************************/
procedure TFormMain.ContentTreeDblClick(Sender: TObject);
var
  List: TStringList;
  Temp: String;
begin
  EditorTabs.Enabled := False;
  try
    if ContentTree.Selected = nil then
      Exit;

    //vr[^uȂҏWɊJ
    if EditorTabs.ActiveTabIndex = 2 then
      EditorTabs.ActiveTabIndex := 0;

    //O̕ҏWf[^̏
    if FActiveEditDate <> nil then
    begin
      if EditorTabs.ActiveTabIndex = 0 then
      begin
        FActiveEditDate.Date := GetBodyHTML;
      end else
      begin
        FActiveEditDate.Date := Editor.Text;
      end;
    end;

    //gsbNŖȂ甲
    if TTopicItem(TTreeView(Sender).Selected.Data).TopicType <> TTPItem then
    begin
      //ҏW\Ȃ甲Ȃ
      if TTopicItem(TTreeView(Sender).Selected.Data).FBookEdit = False then
      begin
        EditorPanel.Hide;
        Exit;
      end;
    end;
    EditorPanel.Show;
    EditBrowser.SetDesignMode(false);
    EditBrowser.Navigate('about:blank');
    while EditBrowser.ReadyState < READYSTATE_INTERACTIVE do
    begin
      Application.HandleMessage;  //ꂪK{
    end;
    EditBrowser.SetDesignMode(true);

    //ҏW邽߂ɓKɃe|fo
    FActiveEditDate := nil;
    FActiveEditTreeNode := nil;
    Temp := CreateTempName(ExtractFilePath(FProjectFullPath),'.htm');
    List := TStringList.Create;
    try
      List.Text := TTopicItem(TTreeView(Sender).Selected.Data).Date;
      List.SaveToFile(Temp);

      if EditorTabs.ActiveTabIndex = 0 then
        EditBrowser.Navigate(Temp) else
        Editor.Text := List.Text;
      while EditBrowser.ReadyState < READYSTATE_INTERACTIVE do
      begin
        Application.HandleMessage;  //ꂪK{
      end;
      FDeleteTempList.Add(Temp);
    finally
      List.Free;
    end;

    ActiveEditFileEditor.Text := ChangeFileExt(
      TTopicItem(TTreeView(Sender).Selected.Data).Path
      ,'.htm');

    FActiveEditTreeNode := TTreeView(Sender).Selected;
    FActiveEditDate := TTopicItem(TTreeView(Sender).Selected.Data);
  finally
    EditorTabs.Enabled := True;
  end;
end;

//*****************************************************************************/
//*                      vr[t@C̐
//*****************************************************************************/
procedure TFormMain.EditorTabsActiveTabChange(Sender: TObject;
  ItemIndex: Integer);
var
  List,AddList: TStringList;
  Temp: String;
  FN: String;
  ls: TStringList;
begin
  if FileExists(FProjectFullPath) = False then
    Exit;

  if (FPrevTabIndex = 0) then
  begin
    Editor.Text := GetBodyHTML;
  end;

  if (FPrevTabIndex = 1) then
  begin
    FN := CreateTempName(ExtractFileDir(FProjectFullPath),'.htm');
    ls := TStringList.Create;
    try
      ls.Text := Editor.Text;
      ls.SaveToFile(FN);
    finally
      ls.Free;
    end;

    ls := TStringList.Create;
    try
      ls.LoadFromFile(FN);

      EditBrowser.SetDesignMode(false);
      EditBrowser.Navigate('about:blank');
      while EditBrowser.ReadyState < READYSTATE_INTERACTIVE do
      begin
        Application.HandleMessage;
      end;
      EditBrowser.SetDesignMode(true);

      EditBrowser.Navigate(FN);
      FDeleteTempList.Add(FN);
      while EditBrowser.ReadyState < READYSTATE_INTERACTIVE do
      begin
        Application.HandleMessage;
      end;      
    finally
      ls.Free;
    end;
  end;

  if (ItemIndex = 1) and (FPrevTabIndex <> 2) then
  begin
    Editor.Text := GetBodyHTML;
  end;

  if (ItemIndex = 2) and (FPrevTabIndex <> 2) then
  begin
    //vr[̐
    List := TStringList.Create;
    AddList := TStringList.Create;
    try
      List.LoadFromFile(ExtractFilePath(FProjectFullPath) +
        FProjectTheme + '\header.htm');
      if (FPrevTabIndex = 1) then
        List.Text := List.Text + Editor.Text else
        List.Text := List.Text + GetBodyHTML;
      AddList.LoadFromFile(ExtractFilePath(FProjectFullPath) +
        FProjectTheme + '\footer.htm');
      List.AddStrings(AddList);
      List.Text := ConvartConst(List.Text,FActiveEditDate,
        FActiveEditTreeNode);

      Temp := CreateTempName(ExtractFilePath(FProjectFullPath),'.htm');
      List.SaveToFile(Temp);
      FDeleteTempList.Add(Temp);
    finally
      AddList.Free;
      List.Free;
    end;
    PreViewBrowser.Navigate(Temp);
  end;

  FPrevTabIndex := ItemIndex;
end;

procedure TFormMain.PreViewBrowserNavigateComplete2(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  //e|
  FreeTempList;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  AllFreeTree;
  AllFreeUserTool;
  ForceDirectories(ExtractFilePath(Application.ExeName) + 'Settings');
  SaveToolBarsPos(ExtractFilePath(Application.ExeName) + 'Settings\tbpos.ini');
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  CaptureEndClick(nil);
  FreeTempList;
  FReOpenList.Free;
  FDeleteTempList.Free;
  if po <> nil then
    FreeLibrary(DLLWnd);
end;

procedure TFormMain.EditBrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  FreeTempList; //e|
end;

procedure TFormMain.aacOpenProjectExecute(Sender: TObject);
begin
  if OpenDialogProject.Execute then
  begin
    LoadFormProject(OpenDialogProject.FileName);
  end;
end;

procedure TFormMain.aacSaveProjectExecute(Sender: TObject);
begin
  if FileExists(FProjectFullPath) then
  begin
    SaveToProject(FProjectFullPath);
    SaveToContents(FProjectFullPath);
  end;
end;

procedure TFormMain.PreViewBrowserNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
begin
  Cancel := True;
end;

procedure TFormMain.aacNewHeaderExecute(Sender: TObject);
var
  F: TNewTopicForm;
begin
  F := TNewTopicForm.Create(self);
  try
    F.Caption := 'VKwb_';
    F.ContextEdit.Text := 'IDH_HELP' + IntToStr(FProjectContextIDInc);
    F.ContextNumEdit.Text := IntToStr(10000 + FProjectContextIDInc);
    F.SpTBXComboBox1.ItemIndex := 0;
    F.BookEdit.Enabled := True;
    if F.ShowModal = mrok then
    begin
      //gsbN
      AddNodeTopic(TTPBook,F.TopicEdit.Text,F.KeyEdit.Text,
        F.ContextEdit.Text,F.ContextNumEdit.Text,
        F.FChild,F.SpTBXComboBox1.ItemIndex);
    end;
  finally
    F.Free;
  end;
end;

procedure TFormMain.aacDelTopicExecute(Sender: TObject);
  procedure Dels(TreeNode: TTreeNode);
  var
    i: integer;
  begin
    for i := TreeNode.Count-1 downto 0 do
      Dels(TreeNode.Item[i]);
    if (TTopicItem(TreeNode.Data).TopicType = TTPItem) or
      (TTopicItem(TreeNode.Data).TopicType = TTPBook) then
    begin
      DeleteFile(ExtractFilePath(FProjectFullPath) +
        TTopicItem(TreeNode.Data).Path);
    end;
    TTopicItem(TreeNode.Data).Free;
    TreeNode.Delete;
  end;
var
  i: Integer;
  TopNode: TTreeNode;
begin
  if MessageDlg('폜sƁATum[h܂߂ׂč폜܂B'+#13#10+
    'NĂgsbNt@C폜܂B'+#13#10+
    '폜sƎIɏ㏑ۑAt@C邽߂蒼ł܂B'+#13#10+
    ''+#13#10+'폜sĂ낵łH'+#13#10
    ,mtWarning,[mbYes,mbNo],0) = mryes then
  begin
    FOnEditFlag := True;
    TopNode := ContentTree.Selected;
    ContentTree.Items.BeginUpdate;
    try
      if TopNode <> nil then
      begin
        FActiveEditDate := nil;
        FActiveEditTreeNode := nil;
        EditorPanel.Hide;
        for i := TopNode.Count - 1 downto 0 do
          Dels(TopNode.Item[i]);
        //I
        if (TTopicItem(TopNode.Data).TopicType = TTPItem) or
          (TTopicItem(TopNode.Data).TopicType = TTPBook) then
        begin
          DeleteFile(ExtractFilePath(FProjectFullPath) +
            TTopicItem(TopNode.Data).Path);
        end;
        TTopicItem(TopNode.Data).Free;
        TopNode.Delete;
      end;
    finally
      ContentTree.Items.EndUpdate;
    end;
    aacSaveProjectExecute(nil);
  end;
end;

procedure TFormMain.aaEditTopicExecute(Sender: TObject);
var
  F: TNewTopicForm;
begin
  if ContentTree.Selected = nil then
    Exit;

  if (TTopicItem(ContentTree.Selected.Data).TopicType = TTPBook) or
     (TTopicItem(ContentTree.Selected.Data).TopicType = TTPItem) then
  begin
    F := TNewTopicForm.Create(self);
    try
      F.Caption := 'ҏW';
      F.SpTBXButton1.Visible := False;
      F.SpTBXButton4.Caption := 'OK(&O)';
      F.SpTBXButton4.Default := True;
      F.SpTBXButton4.Height := F.SpTBXButton2.Height;
      F.SpTBXButton4.Top := F.SpTBXButton2.Top;
      F.SpTBXComboBox1.ItemIndex :=
        TTopicItem(ContentTree.Selected.Data).FImageIndex;

      F.BookEdit.Enabled :=
        (TTopicItem(ContentTree.Selected.Data).TopicType = TTPBook);

      F.BookEdit.Checked := TTopicItem(ContentTree.Selected.Data).FBookEdit;
      F.TopicEdit.Text := TTopicItem(ContentTree.Selected.Data).Name;
      F.KeyEdit.Text := TTopicItem(ContentTree.Selected.Data).Key;
      F.ContextEdit.Text := TTopicItem(ContentTree.Selected.Data).ID;
      F.ContextNumEdit.Text := TTopicItem(ContentTree.Selected.Data).IDNum;
      if F.ShowModal = mrok then
      begin
        //gsbNҏW
        FOnEditFlag := True;
        TTopicItem(ContentTree.Selected.Data).Name := F.TopicEdit.Text;
        TTopicItem(ContentTree.Selected.Data).Key := F.KeyEdit.Text;
        TTopicItem(ContentTree.Selected.Data).ID := F.ContextEdit.Text;
        TTopicItem(ContentTree.Selected.Data).IDNum := F.ContextNumEdit.Text;
        TTopicItem(ContentTree.Selected.Data).FImageIndex :=
          F.SpTBXComboBox1.ItemIndex;
        TTopicItem(ContentTree.Selected.Data).FBookEdit :=
          F.BookEdit.Checked;
        ContentTree.Selected.Text :=
          TTopicItem(ContentTree.Selected.Data).Name;
        SetImage(ContentTree.Selected);
      end;
    finally
      F.Free;
    end;
  end;

end;

procedure TFormMain.ContentTreeEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
  aaEditTopicExecute(nil);
  AllowEdit := False;
end;

procedure TFormMain.aaUpExecute(Sender: TObject);
begin
  FOnEditFlag := True;
  if ContentTree.Selected.getPrevSibling <> nil then
    ContentTree.Selected.MoveTo(ContentTree.Selected.getPrevSibling,naInsert);
end;

procedure TFormMain.aaDownExecute(Sender: TObject);
begin
  FOnEditFlag := True;
  if ContentTree.Selected.getNextSibling <> nil then
    ContentTree.Selected.getNextSibling.MoveTo(ContentTree.Selected,naInsert);
end;

procedure TFormMain.aaLeftExecute(Sender: TObject);
begin
  FOnEditFlag := True;
  if ContentTree.Selected.Parent <> nil then
    if TTopicItem(
      ContentTree.Selected.Parent.Data).TopicType = TTPBook then
      ContentTree.Selected.MoveTo(ContentTree.Selected.Parent,naAdd);
end;

procedure TFormMain.aaRightExecute(Sender: TObject);
begin
  FOnEditFlag := True;
  if ContentTree.Selected.getPrevSibling <> nil then
    if TTopicItem(
      ContentTree.Selected.getPrevSibling.Data).TopicType = TTPBook then
      ContentTree.Selected.MoveTo(ContentTree.Selected.getPrevSibling,naAddChild);
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if FNoCloseInfo = False then
  begin
    if (FProjectFullPath <> '') and (FOnEditFlag = true) then
    begin
      case MessageDlg('SpeedHelpPadI悤ƂĂ܂B'+#13#10+
        '݊JĂvWFNgуgsbN㏑ۑ܂H'+#13#10
        ,mtWarning,[mbYes,mbNo,mbCancel],0) of
      mrYes:
        begin
          aacSaveProjectExecute(nil);
        end;
      mrCancel:
        begin
          CanClose := False;
        end;
      end;
    end;
  end;
end;

procedure TFormMain.aacExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.aacUndoExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.Undo;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.Undo;
end;

procedure TFormMain.aacRedoExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.Redo;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.Redo;
end;

procedure TFormMain.aacCopyExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.Copy;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.CopyToClipboard;
end;

procedure TFormMain.aacCutExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.Cut;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.CutToClipboard;
end;

procedure TFormMain.aacPasteExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.Paste;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.PasteFromClipboard;
end;

procedure TFormMain.aacDeleteExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.Delete;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.SelText := '';
end;

procedure TFormMain.aacSelectAllExecute(Sender: TObject);
begin
  if (EditorTabs.ActiveTabIndex = 0) then
    EditBrowser.SelectAll;
  if (EditorTabs.ActiveTabIndex = 1) then
    Editor.SelectAll;
end;

procedure TFormMain.aacFindExecute(Sender: TObject);
var
  Options: TSynSearchOptions;
begin
  if Assigned(FFindDialog) = False then
    FFindDialog := TFindForm.Create(self);
  if FFindDialog.ShowModal = mrok then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      EditBrowser.FindString(TFindForm(FFindDialog).FindBox.Text,
        TFindForm(FFindDialog).WholeWord.Checked,
        TFindForm(FFindDialog).MatchCase.Checked,
        TFindForm(FFindDialog).FDown);
    end else
    begin
      Options := [];
      //啶̋
      if TFindForm(FFindDialog).MatchCase.Checked then
        Include(Options, ssoMatchCase);
      //
      if not TFindForm(FFindDialog).FDown then
        Include(Options, ssoBackwards);
      //PPʌ
      if TFindForm(FFindDialog).WholeWord.Checked then
        Include(Options, ssoWholeWord);
      Editor.SearchReplace(TFindForm(FFindDialog).FindBox.Text,
        '',Options);
    end;
  end;
end;

procedure TFormMain.aacFindNextExecute(Sender: TObject);
var
  Options: TSynSearchOptions;
begin
  if Assigned(FFindDialog) then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      EditBrowser.FindString(TFindForm(FFindDialog).FindBox.Text,
        TFindForm(FFindDialog).WholeWord.Checked,
        TFindForm(FFindDialog).MatchCase.Checked,
        TFindForm(FFindDialog).FDown);
    end else
    begin
      Options := [];
      //啶̋
      if TFindForm(FFindDialog).MatchCase.Checked then
        Include(Options, ssoMatchCase);
      //
      if not TFindForm(FFindDialog).FDown then
        Include(Options, ssoBackwards);
      //PPʌ
      if TFindForm(FFindDialog).WholeWord.Checked then
        Include(Options, ssoWholeWord);
      Editor.SearchReplace(TFindForm(FFindDialog).FindBox.Text,
        '',Options);
    end;
  end;
end;

procedure TFormMain.aacRepExecute(Sender: TObject);
var
  F: TReplaceForm;
  Options: TSynSearchOptions;
begin
  F := TReplaceForm.Create(self);
  F.SelectCheck.Visible := True;
  if F.ShowModal = mrok then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      if F.AllReplace.Checked then
      begin
        EditBrowser.ReplaceAllString(F.FindBox.Text,
          F.ReplaceBox.Text,
          F.WholeWord.Checked,
          F.MatchCase.Checked,
          F.FDown);
        FOnEditFlag := True;
      end else
      begin
        EditBrowser.ReplaceString(F.FindBox.Text,
          F.ReplaceBox.Text,
          F.WholeWord.Checked,
          F.MatchCase.Checked,
          F.FDown);
        FOnEditFlag := True;
      end;
    end else
    begin
      Options := [ssoReplace];
      if F.SelectCheck.Checked then
        Include(Options, ssoSelectedOnly);
      if F.AllReplace.Checked then
        Include(Options, ssoReplaceAll);
      //啶̋
      if F.MatchCase.Checked then
        Include(Options, ssoMatchCase);
      //
      if not F.FDown then
        Include(Options, ssoBackwards);
      //PPʌ
      if F.WholeWord.Checked then
        Include(Options, ssoWholeWord);
      Editor.SearchReplace(F.FindBox.Text,
        F.ReplaceBox.Text,Options);
      FOnEditFlag := True;
    end;

  end;
end;

procedure TFormMain.aaLinkExecute(Sender: TObject);
var
  F: TLinkForm;
begin
  F := TLinkForm.Create(self);
  F.TreeView1.Items.Assign(ContentTree.Items);
  if EditorTabs.ActiveTabIndex = 0 then
    F.ListBox2.Items.Text := EditBrowser.GetAnchorNames;
  if F.ShowModal = mrok then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      EditBrowser.ExecCommandRapper('Unlink','');
      EditBrowser.ExecCommandRapper('CreateLink',F.LinkEdit.Text);
      FOnEditFlag := True;
    end else
    begin
      Editor.SelText := '<a href="' + F.LinkEdit.Text +
        '">' + Editor.SelText + '</a>';
    end;
  end;
end;

procedure TFormMain.aaImageExecute(Sender: TObject);
var
  F: TImageAddForm;
begin
  F := TImageAddForm.Create(self);
  if F.ShowModal = mrok then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      EditBrowser.ExecCommandRapper('InsertImage',F.LinkEdit.Text);
      FOnEditFlag := True;
    end else
    begin
      Editor.SelText := '<img src="' + F.LinkEdit.Text +
        '">' + Editor.SelText;
    end;
  end;
end;

procedure TFormMain.aaLineExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('InsertHorizontalRule','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<hr>';
  end;
end;

procedure TFormMain.aaBookMarkExecute(Sender: TObject);
var
  str: String;
begin
  str := InputBox('ubN}[N','ubN}[Nw肵Ă','');
  if str = '' then
    Exit;

  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('CreateBookmark',str);
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<a name="' + str + '">' + Editor.SelText + '</a>';
  end;
end;

procedure TFormMain.aaBoldExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('Bold','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<b>' + Editor.SelText + '</b>';
  end;

end;

procedure TFormMain.aaItalicExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('Italic','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<i>' + Editor.SelText + '</i>';
  end;

end;

procedure TFormMain.aaUnderLineExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('Underline','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<u>' + Editor.SelText + '</u>';
  end;

end;

procedure TFormMain.aaListExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('InsertUnorderedList','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<ul><li>' + Editor.SelText + '</li></ul>';
  end;
end;

procedure TFormMain.aaNumListExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('InsertOrderedList','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<ol><li>' + Editor.SelText + '</li></ol>';
  end;
end;

procedure TFormMain.aaLeftYoseExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('JustifyLeft','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<div align="left">' + Editor.SelText + '</div>';
  end;
end;

procedure TFormMain.aaCenterYoseExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('JustifyCenter','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<div align="center">' + Editor.SelText + '</div>';
  end;

end;

procedure TFormMain.aaRightYoseExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('JustifyRight','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<div align="right">' + Editor.SelText + '</div>';
  end;
end;

procedure TFormMain.aaIndentExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('Indent','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<blockquote>' + Editor.SelText + '</blockquote>';
  end;
end;

procedure TFormMain.aaUnIndentExecute(Sender: TObject);
begin
  EditBrowser.ExecCommandRapper('Outdent','');
  FOnEditFlag := True;
end;

procedure TFormMain.aaStrikOutExecute(Sender: TObject);
begin
  if EditorTabs.ActiveTabIndex = 0 then
  begin
    EditBrowser.ExecCommandRapper('StrikeThrough','');
    FOnEditFlag := True;
  end else
  begin
    Editor.SelText := '<s>' + Editor.SelText + '</s>';
  end;
end;

procedure TFormMain.aaEditFontExecute(Sender: TObject);
var
  F: TFontForm;
  InsStr,BackStr: String;
begin
  F := TFontForm.Create(self);
  F.FontEdit.Text := EditBrowser.queryCommandValueRapper('FontName');
  F.SizeBox.ItemIndex := F.SizeBox.Items.IndexOf(
    EditBrowser.queryCommandValueRapper('FontSize'));
  F.ColorBoxx.Text := EditBrowser.queryCommandValueRapper('ForeColor');
  F.BKColorBox.Text := EditBrowser.queryCommandValueRapper('BackColor');
  if F.ShowModal = mrok then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      if F.FontEdit.Text <> '' then
        EditBrowser.ExecCommandRapper('FontName',F.FontEdit.Text);
      if F.SizeBox.Text <> '' then
        EditBrowser.ExecCommandRapper('FontSize',F.SizeBox.Text);
      if F.ColorBoxx.Text <> '' then
        EditBrowser.ExecCommandRapper('ForeColor',F.ColorBoxx.Text);
      if F.BKColorBox.Text <> '' then
        EditBrowser.ExecCommandRapper('BackColor',F.BKColorBox.Text);
      FOnEditFlag := True;
    end else
    begin
      InsStr := '<font';
      BackStr := '</font>';
      if F.FontEdit.Text <> '' then
        InsStr := InsStr + ' face="' + F.FontEdit.Text + '"';
      if F.SizeBox.Text <> '' then
        InsStr := InsStr + ' size="' + F.SizeBox.Text + '"';
      if F.ColorBoxx.Text <> '' then
        InsStr := InsStr + ' color="#' + F.ColorBoxx.Text + '"';
      if F.BKColorBox.Text <> '' then
        InsStr := InsStr + ' style="BACKGROUND-COLOR: #' + F.BKColorBox.Text
          + '"';
      InsStr := InsStr + '>';

      Editor.SelText := InsStr + Editor.SelText + BackStr;
    end;

  end;
end;

procedure TFormMain.aaCustomTagExecute(Sender: TObject);
var
  F: TCustomTagForm;
begin
  F := TCustomTagForm.Create(self);
  try
    if F.ShowModal = mrok then
    begin
      if EditorTabs.ActiveTabIndex = 0 then
      begin
        EditBrowser.PasteHTML(F.FInsertA,F.FInsertB);
        FOnEditFlag := True;
      end else
      begin
        Editor.SelText := F.FInsertA + Editor.SelText + F.FInsertB;
      end;
    end;
  finally
    F.Free;
  end;
end;

procedure TFormMain.aacCaptureExecute(Sender: TObject);
begin
  if FNoEndCapture = False then
  begin
    ShowWindow(Application.Handle,SW_HIDE);
    Hide;
    Application.ShowMainForm := False;
  end;

  RegisterHotKey(Handle, KeyID_AllCapt, MOD_CONTROL, VK_SNAPSHOT);
  RegisterHotKey(Handle, KeyID_WndCapt, 0, VK_SNAPSHOT);
  RegisterHotKey(Handle, KeyID_BoxCapt, MOD_ALT, VK_SNAPSHOT);
  RegisterHotKey(Handle, KeyID_ControlCapt, MOD_SHIFT, VK_SNAPSHOT);

  with NID do
  begin
    cbSize := Sizeof(NID);
    hIcon := Application.Icon.Handle;
    Wnd  := Self.Handle;
    uID := 1;
    szTip := 'SpeedHelpPadLv`[c[';
    uCallbackMessage :=WM_USER + 5458;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  end;

  //ACRǉ
  Shell_NotifyIcon(NIM_ADD, @NID);
end;

procedure TFormMain.CaptureEndClick(Sender: TObject);
begin
  UnregisterHotKey(Handle, KeyID_AllCapt);
  UnregisterHotKey(Handle, KeyID_WndCapt);
  UnregisterHotKey(Handle, KeyID_BoxCapt);
  UnregisterHotKey(Handle, KeyID_ControlCapt);

  Shell_NotifyIcon(NIM_DELETE, @NID);
  ShowWindow(Application.Handle,SW_SHOW);
  MainWndForg;
  Application.ShowMainForm := True;
  Show;
end;

procedure TFormMain.AllCaptureClick(Sender: TObject);
var
  BMP: TBitMap;
  F: TCaptureTool;
begin
  BMP := TBitMap.Create;
  try
    AllWndCapt(BMP);
    F := TCaptureTool.Create(self);
    F.FDefWidth := F.ExportImage.Picture.Width;
    F.FDefHeight := F.ExportImage.Picture.Height;
    F.ExportImage.Picture.Assign(BMP);
    F.ExportImage.Height := F.ExportImage.Picture.Height;
    F.ExportImage.Width := F.ExportImage.Picture.Width;
  finally
    BMP.Free;
  end;
  if FNoEndCapture = False then
    CaptureEndClick(nil);
  F.ShowModal;
end;

procedure TFormMain.WndCaptureClick(Sender: TObject);
var
  BMP: TBitMap;
  F: TCaptureTool;
begin
  BMP := TBitMap.Create;
  try
    ActWndCapt(BMP);
    F := TCaptureTool.Create(self);
    F.ExportImage.Picture.Assign(BMP);
    F.FDefWidth := F.ExportImage.Picture.Width;
    F.FDefHeight := F.ExportImage.Picture.Height;
    F.ExportImage.Height := F.ExportImage.Picture.Height;
    F.ExportImage.Width := F.ExportImage.Picture.Width;
  finally
    BMP.Free;
  end;
  if FNoEndCapture = False then
    CaptureEndClick(nil);
  F.ShowModal;
end;

procedure TFormMain.BoxCaptureClick(Sender: TObject);
var
  BMP,BM2: TBitMap;
  F: TCaptureTool;
begin
  BMP := TBitMap.Create;
  BM2 := TBitMap.Create;
  try
    if BoxWndCapt(BMP,BM2) = False then
    begin
      Exit;
    end;
    F := TCaptureTool.Create(self);
    F.ExportImage.Picture.Assign(BM2);
    F.FDefWidth := F.ExportImage.Picture.Width;
    F.FDefHeight := F.ExportImage.Picture.Height;
    F.ExportImage.Height := F.ExportImage.Picture.Height;
    F.ExportImage.Width := F.ExportImage.Picture.Width;
  finally
    BM2.Free;
    BMP.Free;
  end;
  if FNoEndCapture = False then
    CaptureEndClick(nil);
  F.ShowModal;
end;

procedure TFormMain.ControlCaptureClick(Sender: TObject);
var
  BMP: TBitMap;
  F: TCaptureTool;
begin
  BMP := TBitMap.Create;
  try
    if ControlCapt(BMP) = False then
      Exit;
    F := TCaptureTool.Create(self);
    F.ExportImage.Picture.Assign(BMP);
    F.FDefWidth := F.ExportImage.Picture.Width;
    F.FDefHeight := F.ExportImage.Picture.Height;
    F.ExportImage.Height := F.ExportImage.Picture.Height;
    F.ExportImage.Width := F.ExportImage.Picture.Width;
  finally
    BMP.Free;
  end;
  if FNoEndCapture = False then
    CaptureEndClick(nil);
  F.ShowModal;
end;

procedure TFormMain.aacSourceEditExecute(Sender: TObject);
var
  F: TFormEditSource;
  FN: String;
  ls: TStringList;
begin
  FN := CreateTempName(ExtractFileDir(FProjectFullPath),'.htm');
  ls := TStringList.Create;
  try
    if EditorTabs.ActiveTabIndex = 0 then
      ls.Text := GetBodyHTML else
      ls.Text := Editor.Text;
    ls.SaveToFile(FN);
  finally
    ls.Free;
  end;
  F := TFormEditSource.Create(self);
  F.FEditPath := FN;
  if FileExists(FBodyEditorPath) then
  begin
    F.EditorSelectBox.Text := FBodyEditorPath;
    F.FExecEditor := True;
  end;
  if F.ShowModal = mrok then
  begin
    FOnEditFlag := True;
    ls := TStringList.Create;
    try
      ls.LoadFromFile(FN);

      if EditorTabs.ActiveTabIndex = 0 then
      begin
        EditBrowser.SetDesignMode(false);
        EditBrowser.Navigate('about:blank');
        while EditBrowser.ReadyState < READYSTATE_INTERACTIVE do
        begin
          Application.ProcessMessages;
        end;
        EditBrowser.SetDesignMode(true);

        EditBrowser.Navigate(FN);
      end else
      begin
        Editor.Text := ls.Text;
      end;
      FDeleteTempList.Add(FN);
    finally
      ls.Free;
    end;
  end;
end;

procedure TFormMain.aacExportExecute(Sender: TObject);
var
  dir: String;
begin
  if SelectDirectory2(Handle,'o͐fBNgIĂ' + #13#10 +
    '̃tH_̒ɃvWFNg̃tH_A̒' + #13#10 +
    'Ro[gHTMLt@CGNX|[g܂','',dir) then
  begin
    ForceDirectories(dir + '\' + FProjectTitle);
    ExportCHMProject(dir + '\' + FProjectTitle);
  end;
end;

procedure TFormMain.aacOptionExecute(Sender: TObject);
var
  F: TOptionForm;
begin
  F := TOptionForm.Create(self);
  if F.ShowModal = mrok then
  begin
    ReadIni;
  end;
end;

procedure TFormMain.aacCompileExecute(Sender: TObject);
var
  StrStream,BufStream: TStringStream;
  SecAttrib: TSecurityAttributes;
  hRead, hWrite, hdupread, hdupwrite,Proc: THandle;
  StartInfo: TStartupInfo;
  ProcInfo: TProcessInformation; //܂CreateProcess
  buf: array[0..513] of char; //߂ɂȂƃAbvf[gȂ̂
  CommandLine,depname: String;
  dwStdOut: DWord;
  SXInfo: TShellExecuteInfo;
begin
  if FCompileMode then
    Exit;

  //RpC邩
  aacSaveProjectExecute(aacSaveProject);

  //vWFNgtH_ɂԂ܂
  if self.FProjectHelpType = HT_HTMLHelp then
  begin
    if FileExists(FHTMLHelpCompiler) = False then
    begin
      ShowMessage('HTMLhelpRpCZbgĂ܂B' + #13#10 +
        'ݒ肩ZbgĂ');
      Exit;
    end;

    ExportCHMProject(ExtractFileDir(FProjectFullPath));
    CommandLine := FHTMLHelpCompiler + ' "' +
      ExtractFilePath(FProjectFullPath) + FProjectPathName + '.hhp"';
  end;

  if self.FProjectHelpType = HT_HTMLHelp2 then
  begin
    OutLogList.Clear;

    if DirectoryExists(FHTMLCompDir) = False then
    begin
      ShowMessage('HTMLhelp2RpCZbgĂ܂B' + #13#10 +
        'ݒ肩ZbgĂ');
      Exit;
    end;
    ExportHsXProject(ExtractFileDir(FProjectFullPath));
    CommandLine := '-p "' +
      ExtractFilePath(FProjectFullPath) + FProjectPathName + '.HxC" ' +
      '-r "' + ExtractFileDir(FProjectFullPath) + '" -l "' +
      ExtractFilePath(FProjectFullPath) + FProjectPathName + '.h2log"';
    try
      FCompileMode := True;
      try
        with SXInfo do
        begin
          cbSize := SizeOf(SXInfo);
          fMask := SEE_MASK_NOCLOSEPROCESS;
          Wnd := Application.Handle;
          lpVerb := 'open';
          lpFile := PChar(FHTMLCompDir + '\hxcomp.exe');
          lpParameters := PChar(CommandLine);
          lpDirectory := PChar(ExtractFileDir(FProjectFullPath));
          nShow := SW_SHOW;
        end;
        ShellExecuteEx(@SXInfo);
        while WaitForSingleObject( SXInfo.hProcess, 0) = WAIT_TIMEOUT do
        begin
          Application.ProcessMessages;
          if FCompileMode = False then
            Exit;
        end;
      finally
        FCompileMode := False;
      end;
    finally
      if FileExists(ExtractFilePath(FProjectFullPath) +
        FProjectPathName + '.h2log') then
      begin
        OutLogList.Items.LoadFromFile(ExtractFilePath(FProjectFullPath) +
          FProjectPathName + '.h2log');
        OutLogList.Items.Add('RpCI');
      end;
    end;

    OutLogList.Items.Add('wvo^Ă܂EEE');
    CommandLine := '-n "' + FProjectTitle + '" ' +
      '-d "' + FProjectTitle + '" ' +
      '-i "' + FProjectTitle + '" -s "' +
      ExtractFilePath(FProjectFullPath) + FProjectPathName + '.HxS"';
    ShellExecute(Handle,'open',PChar(FHTMLCompDir + '\hxreg.exe'),
      PChar(CommandLine),nil,SW_HIDE);
    OutLogList.Items.Add('o^I');
    Exit;
  end;

  if self.FProjectHelpType = HT_JavaHelp then
  begin
    OutLogList.Clear;

    OutLogList.Items.Add('JavaHelp̏o͊Jn');
    ExportJavaHelpProject(ExtractFileDir(FProjectFullPath));

    try
      if FileExists(self.FJAR) = False then
      begin
        OutLogList.Items.Add('JAR.exeZbgĂȂ̂ŃA[JCu͍s܂');
      end else
      begin
        FCompileMode := True;
        OutLogList.Items.Add('A[JCuJn');
        try
          with SXInfo do
          begin
            cbSize := SizeOf(SXInfo);
            fMask := SEE_MASK_NOCLOSEPROCESS;
            Wnd := Application.Handle;
            lpVerb := 'open';
            lpFile := PChar(FJAR);
            lpParameters := PChar('-cf ' + FProjectTitle + '.jar ' + '*');
            lpDirectory := PChar(ExtractFileDir(FProjectFullPath));
            nShow := SW_SHOW;
          end;
          ShellExecuteEx(@SXInfo);
          while WaitForSingleObject( SXInfo.hProcess, 0) = WAIT_TIMEOUT do
          begin
            Application.ProcessMessages;
            if FCompileMode = False then
              Exit;
          end;
          OutLogList.Items.Add('A[JCuI');
        finally
          FCompileMode := False;
        end;
      end;
    finally
      OutLogList.Items.Add(
        'JavaHelp̏o͏I(̃A[JCuɂ͖ʂ̂ŁACɂȂl͍ĕҏWĂ)');
    end;
    Exit;
  end;

  OutLogList.Clear;

  FCompileMode := True;
  try
    StrStream := TStringStream.Create('');
    BufStream := TStringStream.Create('');
    try
      StrStream.Position := 0;
      FillChar(SecAttrib, SizeOf(SecAttrib), 0);
      SecAttrib.nLength := SizeOf(SecAttrib);
      SecAttrib.bInheritHandle := true;
      if CreatePipe(hdupread, hWrite, @SecAttrib, SizeOf(buf)) = False then
        Exit;
      if DuplicateHandle(GetCurrentProcess(),
                      hWrite,
                      GetCurrentProcess(),
                      @hdupwrite,
                      0,
                      false,
                      DUPLICATE_SAME_ACCESS) = false then
        Exit;
      CloseHandle(hWrite);
      CreatePipe(hRead, hWrite, @SecAttrib, SizeOf(buf));
      try
        ZeroMemory(@StartInfo, sizeof(StartInfo));
        StartInfo.cb := sizeof(TStartupInfo);
        StartInfo.dwFlags := STARTF_USESTDHANDLES;
        StartInfo.wShowWindow := SW_HIDE;
        StartInfo.hStdInput := hdupread;
        StartInfo.hStdOutput := hWrite;
        if CreateProcess(nil, PChar(CommandLine), @SecAttrib, nil, true,
          DETACHED_PROCESS, nil, nil, StartInfo, ProcInfo) = False then
          Exit;
        try
          OutLogList.Items.Add('sJn܂');
          WaitForInputIdle(GetCurrentProcess, INFINITE);
          repeat
            if FCompileMode = False then
            begin
              Proc := OpenProcess(PROCESS_ALL_ACCESS or PROCESS_TERMINATE
                ,True,ProcInfo.dwProcessId);
              TerminateProcess(Proc,0);
              OutLogList.Items.Add('[U[rh𒆎~܂B');
              Exit;
            end;

            Application.ProcessMessages;
            Sleep(50);
            PeekNamedPipe(hRead, nil, 0, nil, @dwStdOut, nil);
            if (dwStdOut > 0) then
            begin
              FillChar(buf,Length(buf)-1,0);
              ReadFile(hRead, buf, Length(buf) - 1, dwStdOut, nil);
              StrStream.Write(buf,dwStdOut);
              BufStream.Write(buf,dwStdOut);
              OutLogList.Items.BeginUpdate;
              try
                if Length(BufStream.DataString) > 4096 then
                begin
                  OutLogList.Items.Text := Copy(BufStream.DataString,
                    Length(BufStream.DataString)-4096,4096);
                  if OutLogList.Count <> 0 then
                    OutLogList.Items.Delete(0);
                end else
                begin
                  OutLogList.Items.Text := BufStream.DataString;
                end;

                if OutLogList.Count <> 0 then
                  OutLogList.Items.Delete(OutLogList.Items.Count-1);
                OutLogList.ItemIndex := OutLogList.Items.Count-1;
              finally
                OutLogList.Items.EndUpdate;
              end;

            end;
          until (WaitForSingleObject(ProcInfo.hProcess, 0) = WAIT_OBJECT_0);

          //ꔭĔ
          PeekNamedPipe(hRead, nil, 0, nil, @dwStdOut, nil);
          if (dwStdOut > 0) then
          begin
            FillChar(buf,Length(buf)-1,0);
            ReadFile(hRead, buf, Length(buf) - 1, dwStdOut, nil);
            StrStream.Write(buf,dwStdOut);
          end;

          OutLogList.Items.Text := StrStream.DataString;
          OutLogList.ItemIndex := OutLogList.Items.Count-1;
        finally
          CloseHandle(ProcInfo.hProcess);
          CloseHandle(ProcInfo.hThread);
          CloseHandle(hdupread);
        end;
      finally
        CloseHandle(hRead);
        CloseHandle(hWrite);
        CloseHandle(hdupwrite);
      end;
    finally
      BufStream.Free;
      StrStream.Free;
    end;

    //۰
    if self.FProjectHelpType = HT_HTMLHelp then
    begin
      if DirectoryExists(FProjectdeploy) then
      begin
        if FProjectDepName <> '' then
          depname := FProjectDepName else
          depname := FProjectPathName;
        CopyFile(PChar(ExtractFilePath(FProjectFullPath) + FProjectPathName + '.chm'),
          PChar(FProjectdeploy + '\' + depname + '.chm'),False);
      end;
    end;
  finally
    FCompileMode := False;
  end;
end;

procedure TFormMain.aacRunExecute(Sender: TObject);
begin
  if self.FProjectHelpType = HT_HTMLHelp then
  begin
    ShellExecute(Handle,'open',
      PChar(ExtractFilePath(FProjectFullPath) + FProjectPathName + '.chm'),
      nil,nil,SW_SHOW);
  end;

  if self.FProjectHelpType = HT_HTMLHelp2 then
  begin
    if FileExists(FDexpPath) then
    begin
      ShellExecute(Handle,'open',PChar(FDexpPath),
        PChar('/helpcol ms-help://' + FProjectTitle + '/' + FProjectTitle),nil,SW_SHOW);
    end else
    begin
      Beep;
      ShowMessage('HTMLHelp2r[AZbgĂ܂B' + #13#10 +
        'ݒ肩ZbgĂB');
      Exit;
    end;
  end;


  if self.FProjectHelpType = HT_JavaHelp then
  begin
    if FileExists(FHSView) = False then
    begin
      Beep;
      ShowMessage('hsviewer.jarZbgĂ܂B' + #13#10 +
        '̃t@C%JavaHelp%\demos\binfBNg̒ɂ܂');
      Exit;
    end;

    ShellExecute(Handle,'open',
      PChar(FHSView),
      PChar('-helpset "' +
        ExtractFilePath(FProjectFullPath) + FProjectPathName + 'JHS.hs"'),nil,SW_SHOW);
  end;
end;

procedure TFormMain.aaContextIDMapExecute(Sender: TObject);
var
  F: TEditContextID;
  Nd: TTreeNode;
  Item: TListItem;
  i: integer;
begin
  F := TEditContextID.Create(self);
  //gsbNID}܂
  Nd := ContentTree.Items.GetFirstNode;
  while Nd <> nil do
  begin
    Item := F.ListView1.Items.Add;
    Item.ImageIndex := 51;
    Item.Data := Nd;
    Item.Caption := TTopicItem(Nd.Data).ID;
    Item.SubItems.Add(TTopicItem(Nd.Data).IDNum);
    Item.SubItems.Add(TTopicItem(Nd.Data).Name);
    Item.SubItems.Add(TTopicItem(Nd.Data).Path);
    Nd := Nd.GetNext;
  end;
  if F.ShowModal = mrok then
  begin
    FOnEditFlag := True;
    for i := 0 to F.ListView1.Items.Count-1 do
    begin
      TTopicItem(TTreeNode(F.ListView1.Items[i].Data).Data).ID :=
        F.ListView1.Items[i].Caption;
      TTopicItem(TTreeNode(F.ListView1.Items[i].Data).Data).IDNum :=
        F.ListView1.Items[i].SubItems[0];
    end;
  end;
end;

procedure TFormMain.aacHTMLHelpAPIExecute(Sender: TObject);
var
  F: TAPITestForm;
begin
  F := TAPITestForm.Create(self);
  F.ShowModal;
end;

procedure TFormMain.aaDeleteFormatExecute(Sender: TObject);
begin
  EditBrowser.ExecCommandRapper('removeformat','');
  FOnEditFlag := True;
end;

procedure TFormMain.RetProjectSubMenuPopup(Sender: TTBCustomItem;
  FromLink: Boolean);
var
  i: integer;
  Item: TSpTBXItem;
begin
  RetProjectSubMenu.Clear;
  for i := 0 to FReOpenList.Count-1 do
  begin
    if FileExists(FReOpenList[i]) = False then
      Continue;
    Item := TSpTBXItem.Create(self);
    Item.Caption := IntToStr(i+1) + ':' +
      ExtractShortPathName(FReOpenList[i]);
    Item.Hint := FReOpenList[i];
    Item.OnClick := OnReOpen;
    Item.ImageIndex := 40;
    RetProjectSubMenu.Add(Item);
    if i >= 10 then
      Break;
  end;
end;

procedure TFormMain.ContentPopupPopup(Sender: TObject);
var
  Nd: TTreeNode;
  PP: TPoint;
begin
  PP := Mouse.CursorPos;
  PP := ContentTree.ScreenToClient(PP);
  Nd := ContentTree.GetNodeAt(PP.X,PP.Y);
  if Nd <> nil then
    ContentTree.Selected := Nd;
end;

procedure TFormMain.aaSettingProjectExecute(Sender: TObject);
var
  F: TProjectSetForm;
  Nd: TTreeNode;
  i: integer;
begin
  F := TProjectSetForm.Create(self);
  F.TitleEdit.Text := FProjectTitle;
  F.CopyRightEdit.Text := FProjectCopyRight;
  F.WebEdit.Text := FProjectWeb;
  F.DepEdit.Text := FProjectdeploy;
  F.DefNameEdit.Text := FProjectDepName;
  F.HelpType.ItemIndex := FProjectHelpType;
  Nd := ContentTree.Items.GetFirstNode;
  while Nd <> nil do
  begin
    if TTopicItem(Nd.Data).TopicType = TTPItem then
      F.DefaultPage.Items.AddObject(
        TTopicItem(Nd.Data).Name,TTopicItem(Nd.Data));
    Nd := Nd.GetNext;
  end;
  F.DefaultPage.ItemIndex := 0;
  for i := 0 to F.DefaultPage.Items.Count-1 do
  begin
    if TTopicItem(F.DefaultPage.Items.Objects[i]).Path = FProjectTopPage then
    begin
      F.DefaultPage.ItemIndex := i;
      Break;
    end;
  end;
  F.GenTitleNameCheck.Checked := FProjectGenNameTitle;
  if F.ShowModal = mrok then
  begin
    FOnEditFlag := True;
    if F.DefaultPage.ItemIndex <> -1 then
      FProjectTopPage := TTopicItem(
        F.DefaultPage.Items.Objects[F.DefaultPage.ItemIndex]).Path;
    FProjectTitle :=  F.TitleEdit.Text;
    FProjectCopyRight  := F.CopyRightEdit.Text;
    FProjectWeb := F.WebEdit.Text;
    FProjectDepName := F.DefNameEdit.Text;
    FProjectHelpType := F.HelpType.ItemIndex;
    FProjectdeploy := F.DepEdit.Text;
    FProjectGenNameTitle := F.GenTitleNameCheck.Checked;
  end;
end;

procedure TFormMain.aacHelpExecute(Sender: TObject);
begin
  if ActiveControl = ContentTree then
  begin
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051130184730187.htm'),HH_DISPLAY_TOC,0);
    Exit;
  end;
  if ActiveControl = EditBrowser then
  begin
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051130184940328.htm'),HH_DISPLAY_TOC,0);
    Exit;
  end;
  if ActiveControl = OutLogList then
  begin
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051130185659531.htm'),HH_DISPLAY_TOC,0);
    Exit;
  end;
  if ActiveControl = PreViewBrowser then
  begin
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051130185244265.htm'),HH_DISPLAY_TOC,0);
    Exit;
  end;
  if ActiveControl = Editor then
  begin
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051213115819953.htm'),HH_DISPLAY_TOC,0);
    Exit;
  end;
  if ActiveControl = ActiveEditFileEditor then
  begin
    if FileExists(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm') then
      HtmlHelp(Handle,PChar(ExtractFilePath(Application.ExeName) +
        'SpeedHelpPad.chm::/20051127123334281.htm#editpath'),HH_DISPLAY_TOC,0);
    Exit;
  end;
  if po <> nil then
    HtmlHelp(Handle,PChar(
      ExtractFilePath(Application.ExeName) + 'SpeedHelpPad.chm'),
      $0000,0);
end;

procedure TFormMain.aacTutorialExecute(Sender: TObject);
begin
  if po <> nil then
    HtmlHelp(Handle,PChar(
      ExtractFilePath(Application.ExeName) + 'SpeedHelpPad.chm'),
      HH_HELP_CONTEXT,10005);
end;

procedure TFormMain.aacWebExecute(Sender: TObject);
begin
  ShellExecute(Handle,'open',
    'http://textexpage.s154.xrea.com/',nil,nil,SW_SHOW);
end;

procedure TFormMain.aacVarInfoExecute(Sender: TObject);
var
  F: TVarForm;
begin
  F := TVarForm.Create(self);
  F.ShowModal;
end;

procedure TFormMain.UpdateControlEna;
begin
  //܂Ƃ߂ăAbvf[gǗ
  if FileExists(FProjectFullPath) then
  begin
    //vWFNgJĂ
    aacCompile.Enabled := True;
    aacHTMLHelpAPI.Enabled := True;
    if self.FProjectHelpType = HT_JavaHelp then
    begin
      aacRun.Enabled :=
        FileExists(ExtractFilePath(FProjectFullPath) +
        FProjectPathName + 'JHS.hs');
    end;
    if self.FProjectHelpType = HT_HTMLHelp then
    begin
      aacRun.Enabled :=
        FileExists(ExtractFilePath(FProjectFullPath) +
        FProjectPathName + '.chm');
    end;
    if self.FProjectHelpType = HT_HTMLHelp2 then
    begin
      aacRun.Enabled := FileExists(FDexpPath);
    end;
    aacHTMLHelpAPI.Enabled := aacRun.Enabled;
    aacCapture.Enabled := True;
    aaContextIDMap.Enabled := True;
    aaSettingProject.Enabled := True;

    aacSaveProject.Enabled := True;
    aacExport.Enabled := True;
    aacNewTopic.Enabled := True;
    aacNewHeader.Enabled := True;
    if ContentTree.Selected <> nil then
    begin
      aacDelTopic.Enabled := True;
      aaEditTopic.Enabled := True;
      aaUp.Enabled := True;
      aaDown.Enabled := True;
      aaRight.Enabled := True;
      aaLeft.Enabled := True;
    end else
    begin
      aacDelTopic.Enabled := False;
      aaEditTopic.Enabled := False;
      aaUp.Enabled := False;
      aaDown.Enabled := False;
      aaRight.Enabled := False;
      aaLeft.Enabled := False;
    end;
    if (EditorPanel.Visible) and
      ((EditorTabs.ActiveTabIndex = 0) or (EditorTabs.ActiveTabIndex = 1)) and
      (EditBrowser.Document <> nil) then
    begin
      aacSourceEdit.Enabled := True;
      aaLink.Enabled := True;
      aaImage.Enabled := True;
      aaLine.Enabled := True;
      aaBookMark.Enabled :=aaLink.Enabled;
      aaEditFont.Enabled := True;
      aaBold.Enabled := True;
      aaItalic.Enabled := True;
      aaUnderLine.Enabled := True;
      aaStrikOut.Enabled := aaBold.Enabled;
      aaList.Enabled :=True;
      aaNumList.Enabled :=True;
      aaCustomTag.Enabled := aaBold.Enabled;
      aaLeftYose.Enabled := True;
      aaCenterYose.Enabled :=True;
      aaRightYose.Enabled :=True;
      aaIndent.Enabled := True;
      aacInsertTable.Enabled := True;
      if EditorTabs.ActiveTabIndex = 1 then
      begin
        aaUnIndent.Enabled := False;
        aaDeleteFormat.Enabled := False;
        SpHBox.Enabled := False;
      end else
      begin
        aaUnIndent.Enabled := True;
        SpHBox.Enabled := True;
        aaDeleteFormat.Enabled := True;
      end;

      if EditorTabs.ActiveTabIndex = 1 then
      begin
        aacUndo.Enabled := Editor.CanUndo;
        aacRedo.Enabled := Editor.CanRedo;
        aacCopy.Enabled := True;
        aacCut.Enabled := True;
        aacPaste.Enabled := Editor.CanPaste;
        aacDelete.Enabled := True;
        aacSelectAll.Enabled := True;
        aacFind.Enabled := True;
        aacFindNext.Enabled := (Assigned(FFindDialog));
        aacRep.Enabled := True;
      end else
      begin
        aacUndo.Enabled := EditBrowser.CanUndo;
        aacRedo.Enabled := EditBrowser.CanRedo;
        aacCopy.Enabled := EditBrowser.CanCopy;
        aacCut.Enabled := EditBrowser.CanCut;
        aacPaste.Enabled := EditBrowser.CanPaste;
        aacDelete.Enabled := EditBrowser.CanDelete;
        aacSelectAll.Enabled := EditBrowser.CanSelectAll;
        aacFind.Enabled := True;
        aacFindNext.Enabled := (Assigned(FFindDialog));
        aacRep.Enabled := True;
      end;
    end else
    begin
      aacSourceEdit.Enabled := False;
      aaDeleteFormat.Enabled := False;
      SpHBox.Enabled := False;
      aacInsertTable.Enabled := False;

      aaLink.Enabled := False;
      aaImage.Enabled := False;
      aaLine.Enabled := False;
      aaBookMark.Enabled := False;
      aaEditFont.Enabled := False;
      aaBold.Enabled := False;
      aaItalic.Enabled := False;
      aaUnderLine.Enabled := False;
      aaStrikOut.Enabled := False;
      aaList.Enabled := False;
      aaNumList.Enabled := False;
      aaCustomTag.Enabled := False;
      aaLeftYose.Enabled := False;
      aaCenterYose.Enabled := False;
      aaRightYose.Enabled := False;
      aaIndent.Enabled := False;
      aaUnIndent.Enabled := False;

      aacUndo.Enabled := False;
      aacRedo.Enabled := False;
      aacCopy.Enabled := False;
      aacCut.Enabled := False;
      aacPaste.Enabled := False;
      aacDelete.Enabled := False;
      aacSelectAll.Enabled := False;
      aacFind.Enabled := False;
      aacFindNext.Enabled := False;
      aacRep.Enabled := False;
    end;
  end else
  begin
    aacSourceEdit.Enabled := False;
    aacInsertTable.Enabled := False;
    aacHTMLHelpAPI.Enabled := False;
    aacCapture.Enabled := False;
    aaContextIDMap.Enabled := False;
    aaSettingProject.Enabled := False;
    SpHBox.Enabled := False;

    aacSaveProject.Enabled := False;
    aacExport.Enabled := False;
    aacNewTopic.Enabled := False;
    aacNewHeader.Enabled := False;
    aacDelTopic.Enabled := False;
    aaEditTopic.Enabled := False;
    aaUp.Enabled := False;
    aaDown.Enabled := False;
    aaRight.Enabled := False;
    aaLeft.Enabled := False;

    aacUndo.Enabled := False;
    aacRedo.Enabled := False;
    aacCopy.Enabled := False;
    aacCut.Enabled := False;
    aacPaste.Enabled := False;
    aacDelete.Enabled := False;
    aacSelectAll.Enabled := False;
    aacFind.Enabled := False;
    aacFindNext.Enabled := False;
    aacRep.Enabled := False;

    aaLink.Enabled := False;
    aaImage.Enabled := False;
    aaLine.Enabled := False;
    aaBookMark.Enabled := False;
    aaEditFont.Enabled := False;
    aaBold.Enabled := False;
    aaItalic.Enabled := False;
    aaUnderLine.Enabled := False;
    aaStrikOut.Enabled := False;
    aaList.Enabled := False;
    aaNumList.Enabled := False;
    aaCustomTag.Enabled := False;
    aaLeftYose.Enabled := False;
    aaCenterYose.Enabled := False;
    aaRightYose.Enabled := False;
    aaIndent.Enabled := False;
    aaUnIndent.Enabled := False;

    aaDeleteFormat.Enabled := False;

    aacCompile.Enabled := False;
    aacRun.Enabled := False;
    aacHTMLHelpAPI.Enabled := False;
  end;
end;

procedure TFormMain.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
begin
  UpdateControlEna;
  if self.FOnEditFlag then
  begin
    TBXStatusBar1.Panels[4].Caption := 'ҏWς';
  end else
  begin
    TBXStatusBar1.Panels[4].Caption := '';
  end;
end;

function TreeCopy(View: TTreeView; SNode, TNode: TTreeNode): TTreeNode;
var
  NNode: TTreeNode;
  I: integer;
begin
  if TTopicItem(TNode.Data).TopicType = TTPBook  then
    NNode := View.Items.AddChildFirst(TNode,'')
    else
    NNode := View.Items.Insert(TNode,'');
  NNode.Assign(SNode);
  for i := SNode.Count - 1 downto 0 do
  begin
    TreeCopy(View,SNode.Item[i],NNode);
  end;
  Result := NNode;
  View.Items.Delete(SNode);
end;

procedure TFormMain.ContentTreeDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  TNode, SNode: TTreeNode;
begin
  TNode := ContentTree.GetNodeAt(x,y);
  if TNode <> nil then
  begin
    SNode := ContentTree.Selected;
    TNode := TreeCopy(ContentTree,SNode,TNode);
    TNode.Expand(false);
    ContentTree.Selected := TNode;
  end;
end;

procedure TFormMain.ContentTreeDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  TNode,SNode: TTreeNode;
begin
  TNode := ContentTree.GetNodeAt(x,y);
  if (Source = Sender) and (TNode <> nil) then
  begin
    Accept := true;
    SNode := ContentTree.Selected;
    while (TNode.Parent <> nil) and (TNode <> SNode) do
      TNode := TNode.Parent;
    if TNode = SNode then
      Accept := false;
  end else
  begin
    Accept := false;
  end;
end;

procedure TFormMain.SpHBoxChange(Sender: TObject;
  const Text: WideString);
begin
  if Text = 'W' then
  begin
    EditBrowser.PasteInnerouterHTML('<P>',
      '</P>');
  end else
  begin
    EditBrowser.PasteInnerouterHTML('<' + Text + '>',
      '</' + Text + '>');
  end;
end;

procedure TFormMain.EditBrowserEnter(Sender: TObject);
var
  browser: TTKWebBrowser;
  rect: TRect;
begin
  //http://hogehoge2001.at.infoseek.co.jp/note-delphi.html
  browser := TTKWebBrowser(Sender);
  if browser.Document <> nil then
  begin
    Windows.GetClientRect(browser.Handle, rect);
    (browser.Application as IOleObject).DoVerb(OLEIVERB_UIACTIVATE, (* iVerb *)
                                               nil,                 (* lpMsg *)
                                               browser,             (* pActiveSite *)
                                               0,                   (* lindex - reserved *)
                                               browser.Handle,      (* hwndParent *)
                                               rect);               (* display rectangle *)
  end;
end;

procedure TFormMain.TTKMouseGesturesGestureEnd(Sender: TObject);
begin
  TBXStatusBar1.Panels[3].Caption := '';
  FGestureMode := False;
end;

procedure TFormMain.TTKMouseGesturesGestureExec(Sender: TObject);
begin
  UpdateControlEna;
end;

procedure TFormMain.TTKMouseGesturesGestureProgress(Sender: TObject;
  const GestureStr, KeyGesture: String);
begin
  if GestureStr <> '' then
  begin
    if KeyGesture <> '' then
    begin
      TBXStatusBar1.Panels[3].Caption := '' + GestureStr +
        '(' + KeyGesture + ')';
    end else
    begin
      TBXStatusBar1.Panels[3].Caption := '' + GestureStr
    end;
  end;
end;

procedure TFormMain.TTKMouseGesturesGestureStart(Sender: TObject;
  var Cancel: Boolean);
begin
  if Screen.ActiveForm <> nil then
  begin
    if (Screen.ActiveForm.ClassName <> 'TFormMain') then
    begin
      Cancel := True;
      Exit;
    end;
  end;
  FGestureMode := True;
end;

procedure TFormMain.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  TTKMouseGestures.InterruptWHEELGesture(False);
end;

procedure TFormMain.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  TTKMouseGestures.InterruptWHEELGesture(True);
end;

procedure TFormMain.aacInsertTableExecute(Sender: TObject);
var
  F: TTableInsertForm;
  str: String;
  i,x: integer;
begin
  F := TTableInsertForm.Create(self);
  if F.ShowModal = mrok then
  begin
    if EditorTabs.ActiveTabIndex = 0 then
    begin
      EditBrowser.InsertTable(StrToIntDef(F.RowEd.Text,2),
        StrToIntDef(F.ColEd.Text,3),StrToIntDef(F.BorderEd.Text,0),
        F.WidthEd.Text);
      FOnEditFlag := True;
    end else
    begin
      str := '<table border="' + F.BorderEd.Text + '"';
      if F.WidthEd.Text <> '' then
       str := str + ' width="' + F.WidthEd.Text + '"';
      str := str + '>' + #13#10;
      for i := 0 to StrToIntDef(F.RowEd.Text,0)-1 do
      begin
        str := str + '<tr>' + #13#10;
        for x := 0 to StrToIntDef(F.ColEd.Text,0)-1 do
        begin
          str := str + '<td>&nbsp;</td>' + #13#10;
        end;
        str := str + '</tr>' + #13#10;
      end;
      str := str + '</table>';
      Editor.SelText := str;
    end;
  end;
end;

procedure TFormMain.AllFreeUserTool;
var
  i: integer;
begin
  for i := 0 to UserToolSubMenu.Count-1 do
    TObject(UserToolSubMenu[i].Tag).Free;

  UserToolSubMenu.Clear;
end;

procedure TFormMain.UserToolOpen(Sender: TObject);
begin
  ShellExecute(Handle,'open',PChar(
    TUserToolitem(TSpTBXItem(Sender).Tag).Path),nil,nil,SW_SHOW);
end;

procedure TFormMain.UserToolSubMenuPopup(Sender: TTBCustomItem;
  FromLink: Boolean);
var
  i,x: integer;
  Item: TSpTBXItem;
  ls,lsx: TStringList;
  O: TUserToolitem;
  Path: String;
begin
  AllFreeUserTool;

  //ǂݏo
  ls := TStringList.Create;
  lsx := TStringList.Create;
  try
    Path := ExtractFilePath(Application.ExeName) + 'Settings\tools.db';
    if FileExists(Path) then
      ls.LoadFromFile(Path);

    for i := 0 to ls.Count-1 do
    begin
      O := TUserToolitem.Create;
      lsx.Text := StringReplace(ls[i],#9,#13#10,[rfReplaceAll, rfIgnoreCase]);
      for x := 0 to lsx.Count-1 do
      begin
        case x of
        0:O.Name := lsx[x];
        1:O.Path := lsx[x];
        end;
      end;
      Item := TSpTBXItem.Create(self);
      Item.Caption := IntToStr(i+1) + ':' + O.Name;
      Item.Hint := O.Path + '̎s';
      Item.Tag := Integer(O);
      Item.ImageIndex := 60;
      Item.OnClick := UserToolOpen;
      UserToolSubMenu.Add(Item);
    end;
  finally
    lsx.Free;
    ls.Free;
  end;
end;

procedure TFormMain.aacUserToolExecute(Sender: TObject);
var
  F: TUserToolForm;
begin
  F := TUserToolForm.Create(self);
  F.ShowModal;
end;

procedure TFormMain.EditorChange(Sender: TObject);
begin
  FOnEditFlag := true;
end;

procedure TFormMain.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
begin
  case Msg.message of
  WM_KEYDOWN:
    if (IsChild(EditBrowser.Handle, Msg.hwnd)) then
    begin
      //GfBbg
      FOnEditFlag := True;
    end;
  WM_LBUTTONDOWN:
    if (IsChild(EditBrowser.Handle, Msg.hwnd)) then
    begin
      //GfBbg
      FOnEditFlag := True;
    end;
  end;
end;

procedure TFormMain.ContentTreeKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    ContentTreeDblClick(Sender);
  end;
end;

initialization
  OleInitialize(nil);

finalization
  OleUninitialize;


end.
